//}eAp[^
static float Roughness=0.1;//\ʂ̑e
static float Metalic=0;//ۂ
static float Specular=0.5;//XyL
static float4 RMS=saturate(float4(Roughness,Metalic,Specular,0.0));

static float SSSRate=0.0;
static float3 SSSCircle=0.0;
static float4 SSSMat=saturate(float4(SSSCircle.r,SSSCircle.g,SSSCircle.b,SSSRate));





float4 ClearColor = { 0, 0, 0, 0.0 };
float ClearDepth = 0.0;
shared texture2D AlbedoSKrMRTMap	: RenderColorTarget ;
shared texture2D NormalDepthKrMRTMap	: RenderColorTarget ;
shared texture2D MaterialAKrMRTMap	: RenderColorTarget ;
shared texture2D MaterialBKrMRTMap	: RenderColorTarget ;
shared texture2D ZBufferKrMRT	: RenderDepthStencilTarget ;


// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 ProjMatrix		: PROJECTION;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;


float3   LightDirection   : DIRECTION < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*1.6;


float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float    SpecularPower : SPECULARPOWER < string Object = "Geometry"; >;

static float3 MColor2= MaterialEmmisive+MaterialAmbient;
static float3 MColor=pow(MColor2,max(1.0,SpecularPower*0.01));

// eNX`ގ[tl
float4   TextureAddValue   : ADDINGTEXTURE;
float4   TextureMulValue   : MULTIPLYINGTEXTURE;
float4   SphereAddValue    : ADDINGSPHERETEXTURE;
float4   SphereMulValue    : MULTIPLYINGSPHERETEXTURE;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = (float2(0.5, 0.5) / ViewportSize);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}
////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
	float4 Pos      : POSITION;
	float3 Eye    	: TEXCOORD0;
	float2 Tex	    : TEXCOORD1;
	float4 PosW     : TEXCOORD2;
	float4 ScreenTex: TEXCOORD3;
	float3 Normal   : TEXCOORD4;
	float3 Eye2     : TEXCOORD5;
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;


	Out.PosW = mul(Pos, WorldMatrix);

	Out.Normal =Normal;// normalize(mul(Normal, (float3x3)WorldMatrix));

	Out.Pos = mul(Out.PosW,ViewProjMatrix);

	Out.Eye = mul(Out.PosW, ViewMatrix).xyz;
	Out.ScreenTex = Out.Pos;
	Out.Tex = Tex;


	Out.Eye2 = CameraPosition-Out.PosW.xyz;

	return Out;
}


struct OUTPUT_PS {
	float4 AlbedoS : COLOR0;
	float4 NormalDepth    : COLOR1;
	float4 MaterialA    : COLOR2;
	float4 MaterialB    : COLOR3;
};

// sNZVF[_
OUTPUT_PS Basic_PS(VS_OUTPUT IN, float VFace : VFACE,uniform bool useTexture) : COLOR0
{
	OUTPUT_PS PSOut;

	float4 Color=1.0;
	Color.rgb *=saturate(min(length(MColor),1.8)*normalize(MColor));
	float4 TexColor = tex2D(ObjTexSampler, IN.Tex);
	if ( useTexture ) {
	 TexColor.rgb = lerp(1, TexColor.rgb * TextureMulValue.rgb + TextureAddValue.rgb, TextureMulValue.a + TextureAddValue.a);
	Color *= TexColor;
	}
	Color.a *=MaterialDiffuse.a;
	clip(Color.a - 0.1);

	/////////////////////////////////////////////////////////////////////////////////
	PSOut.AlbedoS.rgb = Color.rgb;
	PSOut.AlbedoS.a=max(0.0,SpecularPower-100.0);

	/////////////////////////////////////////////////////////////////////////////////
	float3 Normal = normalize(mul(IN.Normal, (float3x3)WorldMatrix));
	Normal=Normal*VFace;
	PSOut.NormalDepth.rgb = Normal.rgb;
	PSOut.NormalDepth.a = IN.Eye.z;

	/////////////////////////////////////////////////////////////////////////////////
	PSOut.MaterialA.rgba =RMS;
	PSOut.MaterialB.rgba =SSSMat;
	/////////////////////////////////////////////////////////////////////////////////
	return PSOut;
}

technique TechDF < string MMDPass = "object"; bool UseTexture = false;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"


"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"

;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}

}



technique TechDFS < string MMDPass = "object_ss"; bool UseTexture = false;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"

"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"
;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique TechDFTX < string MMDPass = "object"; bool UseTexture = true;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"


"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"

;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}

}



technique TechDFSTX < string MMDPass = "object_ss"; bool UseTexture = true;
string Script =
"ClearSetColor=ClearColor;"
"ClearSetDepth=ClearDepth;"

"RenderColorTarget0=AlbedoSKrMRTMap;"
"RenderColorTarget1=NormalDepthKrMRTMap;"
"RenderColorTarget2=MaterialAKrMRTMap;"
"RenderColorTarget3=MaterialBKrMRTMap;"
"RenderDepthStencilTarget=ZBufferKrMRT;"
"Pass=Draw;"
;
> {

	pass Draw {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}

}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}
technique ZplotTec	< string MMDPass = "zplot"; >{

}

///////////////////////////////////////////////////////////////////////////////////////////////