///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;
///////////////////////////////////////////////////////////////////////////////////
#define TOONTEXTURE "tx/Toon1.png"

#define TOONTEXTURE3 "tx/Canvas.png"

texture ToonTex <
	string ResourceName = TOONTEXTURE;
	int Miplevels = 1;
>;
sampler ToonSamp = sampler_state {
	texture = <ToonTex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};

texture CanvasTex <
	string ResourceName = TOONTEXTURE3;
	int Miplevels = 1;
>;
sampler CanvasSamp = sampler_state {
	texture = <CanvasTex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  =  WRAP;
};

#define NOISENTEX "tx/NoiseN3.png"
#define ScnScale 1.0
#define ScnScale2 0.5
static float LTLength=3.0;//4.0
static float LSZScale=1.0;
float time : TIME;
#define SAMPNUMSSAO 2
#define SAMPNUM 8
#define SAMPNUMSSR 64


#define SAMPNUMSSS2 4

#define SAMPNUMSSAO2 32

#define SAMPNUMS2 2

#define SAMPNUMSS2 4

#define SAMPNUMGI 64
#define SAMPNUMGIS 8
static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
//e

float3 SkyColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = ""; >;
float3 GroundColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "nʊ"; >;
float EnvDefColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "0"; >;
float EnvAllColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "S0"; >;
float SRainRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "J"; >;

float CloudRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "_"; >;
float CloudSpeedRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "_x"; >;
static float CloudTime=(CloudSpeedRate-0.5)*time*0.1;

static float3 SkyColor=(0.05*(1.0-EnvDefColor0)+SkyColor1)*LightColor*(1.0-EnvAllColor0);
static float3 GroundColor=(0.05*(1.0-EnvDefColor0)+GroundColor1)*LightColor*(1.0-EnvAllColor0);

float Si10 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;
float Ry : CONTROLOBJECT < string name = "(self)"; string item = "Ry"; >;
float Rz : CONTROLOBJECT < string name = "(self)"; string item = "Rz"; >;

float X : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float Y : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float Z : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;

//static float LSGIScale = Si10*0.1;
static float SSAORate=(1.0+Rx*180/3.14)*0.5;
static float CanselRate=0.0+Ry*180/3.14;
static float SSAODirRate=Z;
static float SSRRate=1.0+Rz*180/3.14;

static float SSGIRate=(1+X)*32;
static float SSGILumiRate=8.0;
static float SSGIOffFlag=0;

static float ToonRate=Y;
///////////////////////////////////////////////////////////////////////////////////
float4x4 SMat: CONTROLOBJECT < string name = "MainSystem.x"; >;
static float3 SPos = float3(SMat._41, SMat._42, SMat._43);
float ShSi2 : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Si"; >;

static float ShSi = ShSi2*0.1;

float SoftShadowRate : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Tr"; >;


float3    LightDirL1   : DIRECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;

static float3 PosL = SPos  - LightDirection * 3000;


float4 GetLightPos(float3 WPos)
{


	float LYZFlag = step(0.999, pow(LightDirection.y, 2));
	float3 LCrossX = normalize(cross(LightDirection, float3(0.0, LYZFlag, 1.0 - LYZFlag)));
	float3 LCrossY = normalize(cross(LightDirection, LCrossX));

	float4 XYZ = 0;
	float3 WLL=(WPos - PosL);
	XYZ.z = dot(LightDirection, WLL);
	XYZ.x = dot(LCrossX, WLL);
	XYZ.y = dot(LCrossY, WLL);

	XYZ.xy /= 256 * ShSi;


	XYZ.z = (XYZ.z - 500) / (6000 - 500);


	XYZ.w = 1;
	return XYZ;
}



shared texture KrSSHeavyShaMapRT: OFFSCREENRENDERTARGET <
	string Description = "LS";
	int Width =8192;
	int Height =8192;
	string Format = "R32F";
	float4 ClearColor = { 100000, 0, 0, 0 };
	float ClearDepth = 1.0;
	int Miplevels = 1;
	bool AntiAlias = true;
	string DefaultEffect =
		"self = hide;"
		"* = ShadowMap/ShadowMap.fx;";
>;
sampler2D KrSSHeavyShaSamp = sampler_state {
	texture = <KrSSHeavyShaMapRT>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
static float2 SSampStep =1.0 / 8196*0.5;

///////////////////////////////////////////////////////////////////////////////////
//e܂1



float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize)/ScnScale;
static float2 SampStep = (float2(1, 1) / ViewportSize)/ScnScale;
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560/ScnScale;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);





shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D AlbedoMap : RENDERCOLORTARGET ;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET ;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatBMap : RENDERCOLORTARGET ;
sampler2D MatBSamp = sampler_state {
	texture = <MatBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D LumiMap : RENDERCOLORTARGET ;
sampler2D LumiSamp = sampler_state {
	texture = <LumiMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D PLDiffuseMap : RENDERCOLORTARGET;
sampler2D PLDiffuseSamp = sampler_state {
	texture = <PLDiffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D SSAOMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "R16F";
>;
sampler2D SSAOSamp = sampler_state {
	texture = <SSAOMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



texture2D DirShadowAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowASamp = sampler_state {
	texture = <DirShadowAMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D DirShadowBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowBSamp = sampler_state {
	texture = <DirShadowBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D PLSpecularMap : RENDERCOLORTARGET;
sampler2D PLSpecularSamp = sampler_state {
	texture = <PLSpecularMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D DiffuseMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D DiffuseSamp = sampler_state {
	texture = <DiffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};
texture2D BeforeGIMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale2,ScnScale2};
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D BeforeGISamp = sampler_state {
	texture = <BeforeGIMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};
texture2D SSGIMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSGISamp = sampler_state {
	texture = <SSGIMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D SSGIBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSGIBSamp = sampler_state {
	texture = <SSGIBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};
shared texture2D SSSMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSSSamp = sampler_state {
	texture = <SSSMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};
texture2D BeforeSSRMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale2, ScnScale2};
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D BeforeSSRSamp = sampler_state {
	texture = <BeforeSSRMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

texture2D SSRMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSRSamp = sampler_state {
	texture = <SSRMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

texture2D SpecularMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SpecularSamp = sampler_state {
	texture = <SpecularMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D TotalKrSSLMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D TotalKrSSLSamp = sampler_state {
	texture = <TotalKrSSLMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	string Format = "D24S8";
>;

texture2D NoiseNMap <
	string ResourceName = NOISENTEX;
	int MipLevels = 0;
>;
sampler NoiseNSamp = sampler_state {
	texture = <NoiseNMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};

texture2D CloudMap <
	string ResourceName = "tx/Noise4.png";
	int MipLevels = 0;
>;
sampler CloudSamp = sampler_state {
	texture = <CloudMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};
float3	noise2(float2 p) {

	float2 p2 = (p);
	float3 N = 1;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.y+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.x*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);

	
	return N;

}
float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset ;
	return Out;
}
float GetDORate(float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float StartAddScale)
{
	float Rate = 0;
	float2 STex = Tex - TexAdd*StartAddScale;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO2; R += 1) {

		STex += TexAdd*(1.0+R*0.03);
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos.xyz - WPos.xyz);
		float VG = saturate(1.0-distance(normalize(Gap), Normal.xyz)*3);





		Rate += VG;
	}
	Rate = saturate(Rate/SAMPNUMSSAO2*16);
	//Rate = saturate(Rate);
	return Rate;
}
float GetAORate2(float3 BaseNormal,float3 EyeVec, float2 Tex, float3 WPos, float StartAddScale,float3 Noise1)
{
	float Rate = 0;
	
	float3x3 tangentFrame = compute_tangent_frame(BaseNormal, EyeVec, Tex);
	float3 Normal = normalize(lerp(BaseNormal,normalize(mul(normalize(2.0f * saturate(Noise1.rgb) - 1.0f), tangentFrame)),0.5));

	float SSAONScale=0.03;
/*
	float3 SSAOPos = WPos.xyz + Normal.xyz*100;
	float4 SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	float2 TexAdd =normalize(SSAOTex.xy - Tex.xy)*SSAONScale;
*/
	float3 SSAOPos = WPos.xyz + Normal.xyz*4;
	float4 SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	float2 TexAdd =(SSAOTex.xy - Tex.xy)*SSAONScale;


	float2 STex = Tex - TexAdd*StartAddScale;
	float VGS=0;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos - WPos.xyz);
		//float VG = max(0.0,(dot(normalize(Gap),Normal))/(1.0+length(Gap)*0.01));
		//float VG = max(0.0,(distance(normalize(Gap),Normal)/2)/(1.0+length(Gap)*0.01));
		float VG = max(0.0,(1.0-distance(normalize(Gap),Normal)/2)/(1.0+length(Gap)*0.01));
		//VGS=max(VGS,VG);
		Rate+=VG;
	}
	//Rate=VGS;
	Rate = saturate(Rate/ SAMPNUMSSAO);
	Rate =pow(Rate,2.0);	
	return Rate;
}
float3 GetSSRRate(float3 Normal,float3 EyeVec, float2 Tex,  float3 WPos,float StartAddScale,float Roughness,float3 Noise1)
{

	float3 SSRNormal = normalize(reflect(-EyeVec, Normal));
	float3x3 tangentFrame = compute_tangent_frame(SSRNormal, EyeVec, Tex);
	SSRNormal = normalize(lerp(SSRNormal,normalize(mul(normalize(2.0f * saturate(Noise1.rgb) - 1.0f), tangentFrame)),pow(Roughness,2)*0.25));

	float SSRNScale=0.01;
	float3 SSRPos = WPos.xyz + SSRNormal.xyz*100;
	float4 SSRTex = mul(float4(SSRPos, 1.0), ViewProjMatrix);
	SSRTex.x = (1.0f + SSRTex.x / SSRTex.w) * 0.5f;
	SSRTex.y = (1.0f - SSRTex.y / SSRTex.w) * 0.5f;
	float2 TexAdd =normalize(SSRTex.xy - Tex.xy)*SSRNScale;

	float2 STex = Tex - TexAdd*StartAddScale;
	float3 SSRColor = 0;//tex2D(BeforeSSRSamp, STex);

	float Rate =0.0;
	float AORate =0.0;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSR; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos - WPos.xyz);
		float3 NGap = normalize(Gap);
		float VG = saturate(1.0-distance(NGap, SSRNormal.xyz));

		//VG *= 1.0+max(0.0,length(-EyeVec+SSRNormal)-length(-EyeVec+NGap))*100;

		VG=max(0.0,VG-AORate*1000);

		SSRColor += tex2D(BeforeSSRSamp, STex.xy)*VG;
		Rate += VG;	

		AORate=max(AORate,length(-EyeVec+SSRNormal)-length(-EyeVec+NGap));

	}

	SSRColor /= max(1.0,Rate);

	//SSRColor /= SAMPNUMSSR;
	//SSRColor =max(0.0,min(1.0,SSRColor));
	return SSRColor;
}


float3 GetGIRate(float3 Normal,float3 EyeVec, float2 Tex, float3 WPos,float StartAddScale,float3 Noise1)
{
	float Rate =0.0;

	float3x3 tangentFrame = compute_tangent_frame(Normal, EyeVec, Tex);
	float3 GINormal = normalize(lerp(Normal,normalize(mul(normalize(2.0f * saturate(Noise1.rgb) - 1.0f), tangentFrame)),2.0));

	float SSRNScale=0.5/SAMPNUMGI;
	float3 SSRPos = WPos.xyz + GINormal.xyz*100;
	float4 SSRTex = mul(float4(SSRPos, 1.0), ViewProjMatrix);
	SSRTex.x = (1.0f + SSRTex.x / SSRTex.w) * 0.5f;
	SSRTex.y = (1.0f - SSRTex.y / SSRTex.w) * 0.5f;
	float2 TexAdd =normalize(SSRTex.xy - Tex.xy)*SSRNScale;

	float2 STex = Tex - TexAdd*StartAddScale;
	float3 SSRColor = 0;


	[unroll]
	for (int R = 1; R <= SAMPNUMGI; R += 1) {

		STex += TexAdd*R;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos.xyz - WPos.xyz);
		float3 NGap = normalize(Gap);
		float VG = distance(NGap, -GINormal.xyz);
		VG /= length(Gap)*0.1+1.0;
		VG *= saturate(dot(NGap, Normal.xyz));

		float3 AONormal = tex2D(NormalDepthSamp, STex.xy);
		VG *= distance(Normal, -AONormal.xyz)/2;
		VG *= distance(NGap, AONormal.xyz)/2;

		//VG = max(0.0,VG-Rate/R);

		SSRColor += tex2D(BeforeGISamp, STex.xy)*VG;
		//Rate += VG;		

	}



	//SSRColor /= max(1.0,Rate);//SAMPNUMSSR;
	SSRColor = SSRColor/SAMPNUMGI;

	//SSRColor =max(0.0,min(1.0,SSRColor));
	return SSRColor;
}

float4 PS_SSAOA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	


	


	float NoiseTexScale=128;
	float3 Noise1 =noise2(Tex*ViewportSize.xy);
	float GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0, Noise1);
	float GIAORate0 =GIAORate1;


	Noise1 =noise2(Tex*ViewportSize.xy+0.1);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.1, Noise1);
	GIAORate0 += GIAORate1;	

	Noise1 =noise2(Tex*ViewportSize.xy+0.2);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.2, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =noise2(Tex*ViewportSize.xy+0.3);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.3, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =noise2(Tex*ViewportSize.xy+0.4);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.4, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =noise2(Tex*ViewportSize.xy+0.5);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.5, Noise1);
	GIAORate0 += GIAORate1;	
	
	Noise1 =noise2(Tex*ViewportSize.xy+0.6);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.6, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =noise2(Tex*ViewportSize.xy+0.7);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.7, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =noise2(Tex*ViewportSize.xy+0.8);
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.8, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =noise2(Tex*ViewportSize.xy+0.9);


	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.9, Noise1);
	GIAORate0 += GIAORate1;
	GIAORate0/=10;
	GIAORate0*=1.2;
	float GIAORate =  saturate(1.0 - saturate(GIAORate0-CanselRate)*SSAORate);
	Color.rgb = GIAORate ;
	//Color.rgb = lerp(GIAORate,1.0,step(tex2D(MaterialKrSSLSamp,Tex).a,0.0));
	return Color;

}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowA(float2 Tex: TEXCOORD0) : COLOR
{

	float4 ND = tex2D(NormalDepthSamp, Tex);
	float4 WPos = tex2D(WPosSamp, Tex);
	WPos.a = 1.0;
	float3 Normal = ND.rgb;
	float Depth = ND.a;
	float4 Color = 1.0;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float MatAa=tex2D(MatASamp,Tex).a;
	float RFlag=step(1.5,MatAa)*step(MatAa,2.5);
	//float RFlag2=RFlag*saturate(pow(dot(LightDir,-Normal),2)+(max(0.0,dot(LightDir,-EyeVec))*0.13));
	float RFlag2=RFlag*saturate(distance(LightDir,Normal)-1.0);
	//float3 Normal2=normalize(lerp(Normal,LightDir,RFlag2*0.5));
	


	//Color.r = saturate((dot(LightDir, Normal2)) * 80);
	//Color.r = saturate((dot(LightDir, Normal)) * 80);
	float4 ZCalcTex= GetLightPos(WPos.xyz);

	// eNX`Wɕϊ
	ZCalcTex /= ZCalcTex.w;
	float ZTexLength=length(ZCalcTex.xy);
	float2 TransTexCoord;
	TransTexCoord.x = (1.0f + ZCalcTex.x)*0.5f;
	TransTexCoord.y = (1.0f - ZCalcTex.y)*0.5f;
	//TransTexCoord.x += 0.5/4096;
	//TransTexCoord.y -= 0.5/4096;

	
	//float SCor =length(scaleProj)+min(5.0, Depth*0.002)+2.0;
	//float SCorS =10000.0/(1.0+ShSi*0.2);

	float SCor =saturate(Depth*0.005-2)+saturate(1.0-Depth*0.1)+1.0;
	float SCorS =25000.0/(1.0+ShSi*0.2);

	float SSRate = saturate(max(ZCalcTex.z - tex2D(KrSSHeavyShaSamp, TransTexCoord).r, 0.0f) *SCorS - SCor);
	
	float2 SSampStep2=SSampStep*SoftShadowRate;
	
	
	[unroll]
	for (int ix =-SAMPNUMS2; ix <= SAMPNUMS2; ix++) {
	for (int iy = -SAMPNUMS2; iy <= SAMPNUMS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = TransTexCoord+ SSampStep2*AddTexB;
	
		float SColor= tex2D(KrSSHeavyShaSamp, Stex).r;
		SSRate+=saturate(max(ZCalcTex.z - SColor, 0.0f)*SCorS - SCor);

	}
	}
	
	SSRate = 1.0 - saturate(SSRate / (pow(SAMPNUMS2*2 + 1,2)));
	//SSRate = 1.0 - saturate(SSRate);
	float TexFlag=saturate(pow((length(TransTexCoord.xy-0.5))*2,2)-0.75)*4;

	Color.r *=  saturate(SSRate+TexFlag);


	float LSSize=0.025;//(0.02 + max(0.0,Depth*0.002 - 0.5));
	float3 L2Normal = normalize(lerp(-LightDirection, Normal , 0.25));
	float3 DOPos = WPos.xyz + L2Normal;
	float4 DOTex = mul(float4(DOPos, 1.0), ViewProjMatrix);
	DOTex.x = (1.0f + DOTex.x / DOTex.w) * 0.5f;
	DOTex.y = (1.0f - DOTex.y / DOTex.w) * 0.5f;
	float2 DOTexAdd =(DOTex.xy - Tex.xy)*LSSize;
	float SRate = GetDORate(L2Normal, Tex, DOTexAdd, WPos, 0.0);


	Color.r*=saturate(1.0-SRate+RFlag2);//*(1.0-RFlag2);
	//Color.r*=saturate(1.0-SRate);

	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	float4 RMS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular
	float Roughness=RMS.r;
	float RoughnessA=pow(Roughness,2);
	
	float2 STexSampA = SampStep * ViewportSize.y/1080*2;//*pow(distance(EyeVec,Normal),4)*SoftShadowRate*6/min(20,max(1.0,Depth*0.1));
	float2 stexAdd = 0;
	float FColor = tex2D(DirShadowASamp, Tex).r;
	float VGT = 1.0;
	
	[unroll]
	for (int ix =-SAMPNUMSS2; ix <= SAMPNUMSS2; ix++) {
	for (int iy = -SAMPNUMSS2; iy <= SAMPNUMSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;
		
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG =saturate(1.0-distance(AONormal.xyz, Normal.xyz)*4);


		VG *=saturate(1.0-distance(AONormal.a, Depth)*10);







		float SColor2 = tex2D(DirShadowASamp, Stex).r;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	FColor /=VGT;	
	Color.r=saturate(FColor);





	return Color;
}



////////////////////////////////////////////////////////////////////////////////////////////////

/*
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float A = 1 - 0.5*(RoughnessA / (RoughnessA + 0.33));
	float B = 0.45*(RoughnessA / (RoughnessA + 0.09));

	float dotEN = saturate(dot(EyeVec, Normal));
	float dotLN = saturate(dot(LightDir, Normal));

	float alpha = max(acos(dotEN), acos(dotLN));
	float beta = min(acos(dotEN), acos(dotLN));

	float D = sin(alpha) * tan(beta);

	float gamma = dot(normalize(EyeVec - Normal * dotEN), normalize(LightDir - Normal * dotLN));
	float C = max(0, gamma);
	//float4  OrNer = max(0.0f, dot(Normal, l)) * (A + B * C * D);

	float Diffuse = dotLN *(A + B * C * D);
	return Diffuse;
}
*/
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float dotLN = saturate(dot(LightDir, Normal));
	float Diffuse = dotLN;
	return Diffuse;
}


float4 PS_Diffuse(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular
	float Roughness=RMS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMS.g;
	float Specular=RMS.b;

	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	//float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	//float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);

	float MatAa=RMS.a;
	float RFlag=step(1.5,MatAa)*step(MatAa,2.5);
	float RFlag2=RFlag*saturate(distance(LightDir,Normal)-1.0);
	//float RFlag2=RFlag*saturate(pow(dot(LightDir,-Normal),2)+(max(0.0,dot(LightDir,-EyeVec))*0.13));

	ShadowRate*= saturate(max(0.0,(dot(LightDir, Normal)) * 80)+RFlag2);

	Normal=normalize(lerp(Normal,LightDir,RFlag2));


	float SSAORateB=tex2D(SSAOSamp,Tex);

	float DiffuseRate=GetDif(Normal, LightDir, EyeVec, RoughnessA);
	float Dif=DiffuseRate*ShadowRate.r;
	float3 EnvColor=SkyColor*saturate(dot(normalize(LightDir*0.3+float3(0.0,1.0,0.0)),Normal)*0.5+0.5)+GroundColor*saturate(dot(normalize(-LightDir*0.3+float3(0.0,-1.0,0.0)),Normal)*0.5+0.5);

	float3 CloudColor=lerp(1.0,pow(tex2D(CloudSamp,WPos.xz*0.0004+CloudTime),1.0/2),CloudRate);
	float3 TotalDiffuseColor=Dif*LightColor/ 3.141592*lerp(1.0,SSAORateB,SSAODirRate)*(1.0+RFlag2);
	
	TotalDiffuseColor+=EnvColor*SSAORateB;

	TotalDiffuseColor*=CloudColor;

	TotalDiffuseColor+=tex2D(PLDiffuseSamp,Tex);

	//Toonp
	//float3 DiffuseToon=TotalDiffuseColor.rgb;
	//DiffuseToon=(min(1.5,round(length(DiffuseToon)*0.7)+0.4))*normalize(DiffuseToon);

	//float3 DiffuseToon=TotalDiffuseColor.rgb;
	//DiffuseToon=(round(length(DiffuseToon))*0.5+0.5)*normalize(DiffuseToon);
	//TotalDiffuseColor=DiffuseToon;

	Color.rgb=TotalDiffuseColor;
	
	
	return Color;
}







float4 PS_BeforeGI(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	////////////////////////////////////////////////////////////////////////////////////
	
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);

	float4 RMS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular
	float Metalic=RMS.g;
	Color.rgb=tex2D(DiffuseSamp,Tex)*(1.0-Metalic)*Albedo.rgb+tex2D(LumiSamp,Tex).rgb;
	return Color;
}

float4 PS_SSGI(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	////////////////////////////////////////////////////////////////////////////////////
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float3 Noise1 =noise2(Tex*ViewportSize.xy);


	float3 GIColor = GetGIRate(Normal,EyeVec,Tex,WPos,0.0,Noise1);




	Color.rgb=max(0.0001,GIColor.rgb)*min(1.0,(length(scaleProj)+0.1))*min(1.0,Depth*0.05);

	Color.rgb*=SSGIRate;



	return Color;
}

float4 PS_SSGIB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(SSGISamp, Tex);
	////////////////////////////////////////////////////////////////////////////////////
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float2 STexSampA = SampStep * ViewportSize.y/1080*10/min(20,max(1.0,Depth*0.1));//*pow(distance(EyeVec,Normal),4)
	float2 stexAdd = 0;
	float3 FColor = tex2D(SSGISamp, Tex).rgb;
	float VGT = 1.0;
	
	[unroll]
	for (int ix =-SAMPNUMGIS; ix <= SAMPNUMGIS; ix++) {
	for (int iy = -SAMPNUMGIS; iy <= SAMPNUMGIS; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;
		
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG =saturate(1.0-distance(AONormal.xyz, Normal.xyz));

		//VG *=saturate(1.0-distance(AONormal.xyz, Normal.xyz)*2);
		VG *=saturate(1.0-distance(AONormal.a, Depth));

		float3 SColor2 = tex2D(SSGISamp, Stex).rgb;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	Color.rgb=FColor /VGT;	
	Color.rgb+=tex2D(DiffuseSamp,Tex);
	float3 ToonColor=tex2D(ToonSamp,float2(0.5,1.0-length(Color.rgb)/1.7))*1.7*normalize(Color.rgb);
	Color.rgb=lerp(Color.rgb,ToonColor,ToonRate);

	float SSAORateB=tex2D(SSAOSamp,Tex);
	Color.rgb*=SSAORateB;

	return Color;
}

float4 PS_SSS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular
	float4 SSSMat=tex2D(MatBSamp,Tex);
	float Roughness=RMS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMS.g;
	float Specular=RMS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 SSSCircle=SSSMat.rgb;
	float3 SSSColor=Albedo.rgb;
	float SSSRate= SSSMat.a;

	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////

	
	
	float3 TotalDiffuse=tex2D(SSGIBSamp, Tex);
	float3 TotalDiffuseSSS=TotalDiffuse;
	float2 SSSSampStep = SampStep2 / max(1.0, min(100.0, Depth*scaleProj))*100;
	
	
	
	float SSSRateS = 0.0;
	float2 STexSampA =SSSSampStep*SSSCircle.r;
	float TotalDiffuseSSS1 = 0;
	float SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(SSGIBSamp, Stex).r;
		float SSSRateS1 = tex2D(MatBSamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*16,2));
		TotalDiffuseSSS.r += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.r=lerp(TotalDiffuse.r,TotalDiffuseSSS.r / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.g;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(SSGIBSamp, Stex).g;
		float SSSRateS1 = tex2D(MatBSamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*16,2));
		TotalDiffuseSSS.g += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.g=lerp(TotalDiffuse.g,TotalDiffuseSSS.g / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.b;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(SSGIBSamp, Stex).b;
		float SSSRateS1 = tex2D(MatBSamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*16,2));
		TotalDiffuseSSS.b += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.b=lerp(TotalDiffuse.b,TotalDiffuseSSS.b / SSSRateS,step(0.00001,SSSRateS));
	
	

	TotalDiffuse = lerp(TotalDiffuse, TotalDiffuseSSS, saturate(SSSRate*SSSColor));
	
	
	Color.rgb =TotalDiffuse*(1.0-Metalic)*Albedo.rgb;


	float MatAa=tex2D(MatASamp,Tex).a;
	float PlaneFlag=step(0.5,MatAa)*step(MatAa,1.5);

	Color.rgb = lerp(Color.rgb, Albedo.rgb,PlaneFlag);
	
	return Color;
}


float GetSp(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA, float F0)
{
	float3 HalfVec = normalize(EyeVec + LightDir);
	float DotNL = max(0.00000001, saturate(dot(Normal, LightDir)));
	float DotNE = max(0.00000001, saturate(dot(Normal, EyeVec)));
	float DotNH = max(0.00000001, saturate(dot(Normal, HalfVec)));
	float DotEH = max(0.00000001, saturate(dot(EyeVec, HalfVec)));
	float DotLH = max(0.00000001, saturate(dot(LightDir, HalfVec)));

	float D = pow(RoughnessA, 2) / (3.14159265*pow(pow(DotNH, 2)*(pow(RoughnessA, 2) - 1) + 1, 2));
	float F = F0 + (1 - F0)*pow(1.0 - DotEH, 5);
	float G = min(1.0, min(2 * DotNH*DotNE / DotEH, 2 * DotNH*DotNL / DotEH));
	float Specular = F*D*G / (4 * DotNE*DotNL);// +0.0001);

	Specular = max(0.0, min(2.0, Specular));

	return Specular;
}



float4 PS_BeforeSSRA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(SSSSamp,Tex);


	return Color;

}

float4 PS_SSRA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMSS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=lerp(RMSS.b,1.0,SRainRate);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float3 Noise1 =noise2(Tex*ViewportSize.xy);
	float3 SSRRate1 = GetSSRRate(Normal,EyeVec, Tex, WPos,0.0,Roughness,Noise1);

	SSRRate1*=pow(distance(EyeVec,Normal)/2,2);
	float3 FColor=SSRRate1.rgb;
	///////////////////////////////////////////////////////////////////////////////////////////////////
	float3 SpecularAlbedo = lerp(Specular, Albedo.rgb, saturate(Metalic));
	Color.rgb=FColor*SpecularAlbedo*saturate((0.75- Roughness)/0.75+Metalic)*SSRRate;

	return Color;

}


float4 PS_Specular(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SSSSamp,Tex);
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMS.g;
	float F0 = lerp(F0Def, F0MetalDef, saturate(Metalic+(1.0-Roughness)*0.05));
	float Specular=lerp(RMS.b,1.0,SRainRate);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////


	ShadowRate*= saturate(max(0.0,(dot(LightDir, Normal)) * 80));
	
	
	float3 SpecularAlbedo = lerp(Specular, Albedo.rgb, saturate(Metalic));
	
	float3 SpecularColor =  GetSp(Normal, LightDir, EyeVec, RoughnessA, F0)*LightColor* SpecularAlbedo*ShadowRate.r;

	//float3 EnvColor=SkyColor*GetSp(Normal, normalize(LightDir-Normal*4+float3(0.0,1.5,0.0)), EyeVec, RoughnessA, F0);
	//EnvColor+=GroundColor*GetSp(Normal, normalize(-LightDir-Normal*2+float3(0.0,-1.5,0.0)), EyeVec, RoughnessA, F0);
	//EnvColor*=SpecularAlbedo*0.1;
	//SpecularColor+=EnvColor;

	SpecularColor+=tex2D(PLSpecularSamp,Tex)* SpecularAlbedo;

	
	float ENDotR=max(0.0,2.0-dot(EyeVec,ND.xyz));
	
	float3 SSRColor=tex2D(SSRSamp,Tex);
	float2 SSRSampStep=SampStep2*8;
	SSRColor+=tex2D(SSRSamp,Tex+SSRSampStep);
	SSRColor+=tex2D(SSRSamp,Tex-SSRSampStep);
	SSRColor+=tex2D(SSRSamp,Tex+float2(SSRSampStep.x,0.0));
	SSRColor+=tex2D(SSRSamp,Tex+float2(-SSRSampStep.x,0.0));
	SSRColor+=tex2D(SSRSamp,Tex+float2(0.0,SSRSampStep.y));
	SSRColor+=tex2D(SSRSamp,Tex+float2(0.0,-SSRSampStep.y));
	SSRColor+=tex2D(SSRSamp,Tex+float2(-SSRSampStep.x,SSRSampStep.y));
	SSRColor+=tex2D(SSRSamp,Tex+float2(SSRSampStep.x,-SSRSampStep.y));
	SpecularColor+=SSRColor/9;

	
	//Color.rgb=SpecularColor;
	float SSAORateB=tex2D(SSAOSamp,Tex);
	SpecularColor.rgb=SpecularColor*SSAORateB;
	float3 ToonColor=tex2D(ToonSamp,float2(0.5,1.0-length(SpecularColor.rgb)/1.7))*1.7*normalize(SpecularColor.rgb);
	Color.rgb=lerp(SpecularColor.rgb,ToonColor,ToonRate);


	return Color;
}

float4 PS_TotalKrSSL(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SpecularSamp,Tex);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	Color.rgb +=tex2D(SSSSamp,Tex);
	//float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	//float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float MatAa=tex2D(MatASamp,Tex).a;
	float PlaneFlag=step(0.5,MatAa)*step(MatAa,1.5);

	Color.rgb = lerp(Color.rgb, Albedo.rgb,PlaneFlag);



	//Color.rgb=tex2D(SSGIBSamp,Tex).rgb;

	Color.rgb = pow(Color.rgb, 1.0/2.2);

	//Color.rgb=tex2D(SSAOSamp,Tex).r*0.5;
     // Color.rgb=tex2D(NormalDepthSamp,Tex)*0.5+0.5;
	//Color.rgb=tex2D(SSRSamp,Tex);
	//Color.rgb =tex2D(NoiseNSamp,Tex*ViewportSize.xy/128);

	//float RFlag=step(1.5,Mat2.y)*step(Mat2.y,3.5);
	//Color.rgb =RFlag;
	Color.rgb = min(5.0,max(0.0,Color.rgb));
	return Color;
}



technique FILTER <
	string Script =

	"RenderColorTarget0=SSAOMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSAOA;"

	"RenderColorTarget0=DirShadowAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowA;"
	
	"RenderColorTarget0=DirShadowBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowB;"

	"RenderColorTarget0=DiffuseMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Diffuse;"

	"RenderColorTarget0=BeforeGIMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=BeforeGI;"

	"RenderColorTarget0=SSGIMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSGI;"

	"RenderColorTarget0=SSGIBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSGIB;"

	"RenderColorTarget0=SSSMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSS;"


	"RenderColorTarget0=BeforeSSRMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=BeforeSSRA;"


	"RenderColorTarget0=SSRMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSRA;"

	"RenderColorTarget0=SpecularMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Specular;"
	
	"RenderColorTarget0=TotalKrSSLMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=TotalKrSSL;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ScriptExternal=Color;"

	;

> {
	pass SSAOA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSAOA();
	}
	pass DirShadowA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowA();
	}
	pass DirShadowB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowB();
	}

	pass Diffuse < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Diffuse();
	}

	pass BeforeGI < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_BeforeGI();
	}
	pass SSGI < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSGI();
	}
	pass SSGIB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSGIB();
	}
	pass SSS < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSS();
	}
	pass BeforeSSRA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_BeforeSSRA();
	}
	pass SSRA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSRA();
	}
	pass Specular < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Specular();
	}
	pass TotalKrSSL < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_TotalKrSSL();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
