float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;



float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;	
float Scale : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;

static float Si=Scale*0.1;
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 ViewportOffset2 = (float2(1.0,1.0)/ViewportSize)*Si;
static float2 SampStep = (float2(1.0,1.0)/ViewportSize);
float time2 : TIME;
static float time=time2*3000;
static float time3=(time2-1000/60)*3000;

float3	LightPosition	: POSITION  < string Object = "Light"; >;
float3	LightDirection	: DIRECTION < string Object = "Light"; >;
float3	LightDiffuse	: DIFFUSE   < string Object = "Light"; >;
float3	LightAmbient	: AMBIENT   < string Object = "Light"; >;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix           : VIEWPROJECTION;

#define SAMPNUM 7

float ClearDepth  = 1.0;
float4 ClearColor = float4(0, 0, 0, 1);

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};


////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;
    return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passDraw(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp, Tex);
	float2 SampStepRate = SampStep;

	float3 ColorSampX0 = tex2D(ScnSamp, Tex + float2(-SampStepRate.x, 0.0)).rgb;
	float3 ColorSampY0 = tex2D(ScnSamp, Tex + float2(0.0, -SampStepRate.y)).rgb;
	float3 ColorSampY2 = tex2D(ScnSamp, Tex + float2(0.0, SampStepRate.y)).rgb;
	float3 ColorSampX2 = tex2D(ScnSamp, Tex + float2(SampStepRate.x, 0.0)).rgb;

	float XEdgeR = ColorSampX2.r - ColorSampX0.r;
	float YEdgeR = ColorSampY2.r - ColorSampY0.r;

	float XEdgeG = ColorSampX2.g - ColorSampX0.g;
	float YEdgeG = ColorSampY2.g - ColorSampY0.g;

	float XEdgeB = ColorSampX2.b - ColorSampX0.b;
	float YEdgeB = ColorSampY2.b - ColorSampY0.b;


	float2 EdgeRateR =float2(-YEdgeR, XEdgeR)*ViewportOffset2*sin(time);
	float2 EdgeRateG = float2(-YEdgeG, XEdgeG)*ViewportOffset2*sin(time);
	float2 EdgeRateB = float2(-YEdgeB, XEdgeB)*ViewportOffset2*sin(time);

	float4 Color2 = Color;
	Color2.r = tex2D(ScnSamp, Tex+EdgeRateR).r;
	Color2.g = tex2D(ScnSamp, Tex+EdgeRateG).g;
	Color2.b = tex2D(ScnSamp, Tex+EdgeRateB).b;

	float2 EdgeRateR3 = float2(-YEdgeR, XEdgeR)*ViewportOffset2*sin(time3);
	float2 EdgeRateG3 = float2(-YEdgeG, XEdgeG)*ViewportOffset2*sin(time3);
	float2 EdgeRateB3 = float2(-YEdgeB, XEdgeB)*ViewportOffset2*sin(time3);

	float4 Color3 = Color;
	Color3.r = tex2D(ScnSamp, Tex+EdgeRateR3).r;
	Color3.g = tex2D(ScnSamp, Tex+EdgeRateG3).g;
	Color3.b = tex2D(ScnSamp, Tex+EdgeRateB3).b;

	Color=lerp(Color3,Color2,0.5);
	//Color=(Color+Color2+Color3)/3;//
		return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
technique AA <
	string Script =

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Draw;"
	;


> {
	pass Draw < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passDraw();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
