///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;
///////////////////////////////////////////////////////////////////////////////////

static float SSRAABlurScale=1.0;

#define SAMPNUMS 16
#define SAMPNUMS2 4
#define SAMPNUMSS 16
#define SAMPNUMSS2 8
#define SAMPNUMAA 16

#define SAMPNUMSSS2 8

static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;



static float3 LightColor = LightSpecular*5;
//e
///////////////////////////////////////////////////////////////////////////////////
float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);


float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;


float Rx : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Rx"; >;
float Ry : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Ry"; >;
float Rz : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Rz"; >;
float Tr : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Tr"; >;




//
float SiD : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float XD : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float YD : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float ZD : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;

float3 xyzD : CONTROLOBJECT < string name = "(self)"; string item = "XYZ"; >;
static float3 SkyColor=(xyzD*0.01+0.05)*LightColor*SiD*0.1 ;

float3 RxyzD : CONTROLOBJECT < string name = "(self)"; string item = "Rxyz"; >;
static float3 GroundColor=(RxyzD*180/3.14*0.01+0.05)*LightColor*SiD*0.1 ;

float TrD : CONTROLOBJECT < string name ="(self)"; string item = "Tr"; >;


float SRainRate : CONTROLOBJECT < string name = "閧̃Rg[[.pmx"; string item = "J"; >;


float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(1.0, 1.0) / ViewportSize);
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560;

float ClearDepth = 1.0;
float4 ClearColor= float4(0,0,0,1);



shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


shared texture2D AlbedoMap : RENDERCOLORTARGET;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET ;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D DirShadowBMap : RENDERCOLORTARGET ;
sampler2D DirShadowBSamp = sampler_state {
	texture = <DirShadowBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D DiffuseMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D DiffuseSamp = sampler_state {
	texture = <DiffuseMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D SSSMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSSSamp = sampler_state {
	texture = <SSSMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};




shared texture2D SpecularMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SpecularSamp = sampler_state {
	texture = <SpecularMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D TotalKrSSLMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D TotalKrSSLSamp = sampler_state {
	texture = <TotalKrSSLMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D LumiMap : RENDERCOLORTARGET ;
sampler2D LumiSamp = sampler_state {
	texture = <LumiMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

shared texture2D PLDiffuseMap : RENDERCOLORTARGET;
sampler2D PLDiffuseSamp = sampler_state {
	texture = <PLDiffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D PLSpecularMap : RENDERCOLORTARGET;
sampler2D PLSpecularSamp = sampler_state {
	texture = <PLSpecularMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);
	
	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}

///////////////////////////////////////////////////////////////////////////////////////////////












////////////////////////////////////////////////////////////////////////////////////////////////
/*
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float A = 1 - 0.5*(RoughnessA / (RoughnessA + 0.33));
	float B = 0.45*(RoughnessA / (RoughnessA + 0.09));

	float dotEN = saturate(dot(EyeVec, Normal));
	float dotLN = saturate(dot(LightDir, Normal));

	float alpha = max(acos(dotEN), acos(dotLN));
	float beta = min(acos(dotEN), acos(dotLN));

	float D = sin(alpha) * tan(beta);

	float gamma = dot(normalize(EyeVec - Normal * dotEN), normalize(LightDir - Normal * dotLN));
	float C = max(0, gamma);
	//float4  OrNer = max(0.0f, dot(Normal, l)) * (A + B * C * D);

	float Diffuse = dotLN *(A + B * C * D);
	return Diffuse;
}
*/
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float dotLN = saturate(dot(LightDir, Normal));
	float Diffuse = dotLN;
	return Diffuse;
}


float4 PS_Diffuse(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	float DiffuseRate=GetDif(Normal, LightDir, EyeVec, RoughnessA);
	float Dif=DiffuseRate*ShadowRate.r;
	float3 TotalDiffuseColor=Dif*LightColor/ 3.141592;
	
	TotalDiffuseColor+=tex2D(PLDiffuseSamp,Tex);
	

	float3 EnvColor=SkyColor*saturate(dot(normalize(LightDir*0.3+float3(0.0,1.0,0.0)),Normal)*0.5+0.5)+GroundColor*saturate(dot(normalize(-LightDir*0.3+float3(0.0,-1.0,0.0)),Normal)*0.5+0.5);

	TotalDiffuseColor+=EnvColor;

	Color.rgb=TotalDiffuseColor;
	
	
	return Color;
}




float4 PS_SSS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	float3 SSSCircle=normalize(pow(Albedo.rgb,16))*0.8;
	float3 SSSColor=normalize(pow(Albedo.rgb,16));
	float SSSRate= RMSS.a;
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////

	
	
	float3 TotalDiffuse=tex2D(DiffuseSamp, Tex);
	float3 TotalDiffuseSSS=TotalDiffuse;
	float2 SSSSampStep = SampStep2 / max(1.0, min(100.0, Depth*scaleProj))*30;
	
	
	
	float SSSRateS = 0.0;
	float2 STexSampA =SSSSampStep*SSSCircle.r;
	float TotalDiffuseSSS1 = 0;
	float SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).r;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*8,2));
		TotalDiffuseSSS.r += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.r=lerp(TotalDiffuse.r,TotalDiffuseSSS.r / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.g;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).g;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*8,2));
		TotalDiffuseSSS.g += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.g=lerp(TotalDiffuse.g,TotalDiffuseSSS.g / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.b;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).b;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*8,2));
		TotalDiffuseSSS.b += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.b=lerp(TotalDiffuse.b,TotalDiffuseSSS.b / SSSRateS,step(0.00001,SSSRateS));
	
	

	TotalDiffuse = lerp(TotalDiffuse, TotalDiffuseSSS, saturate(SSSRate*SSSColor));
	
	
	Color.rgb =TotalDiffuse*(1.0-Metalic);

	
	return Color;
}


float GetSp(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA, float F0)
{
	float3 HalfVec = normalize(EyeVec + LightDir);
	float DotNL = max(0.00000001, saturate(dot(Normal, LightDir)));
	float DotNE = max(0.00000001, saturate(dot(Normal, EyeVec)));
	float DotNH = max(0.00000001, saturate(dot(Normal, HalfVec)));
	float DotEH = max(0.00000001, saturate(dot(EyeVec, HalfVec)));
	float DotLH = max(0.00000001, saturate(dot(LightDir, HalfVec)));

	float D = pow(RoughnessA, 2) / (3.14159265*pow(pow(DotNH, 2)*(pow(RoughnessA, 2) - 1) + 1, 2));
	float F = F0 + (1 - F0)*pow(1.0 - DotEH, 5);
	float G = min(1.0, min(2 * DotNH*DotNE / DotEH, 2 * DotNH*DotNL / DotEH));
	float Specular = F*D*G / (4 * DotNE*DotNL);// +0.0001);

	Specular = max(0.0, min(2.0, Specular));

	return Specular;
}




float4 PS_Specular(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SSSSamp,Tex);
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMSS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float F0 = lerp(F0Def, F0MetalDef, saturate(Metalic+(1.0-Roughness)*0.05));
	float Specular=lerp(RMSS.b,1.0,SRainRate);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	
	
	float3 SpecularAlbedo = lerp(Specular, Albedo.rgb, saturate(Metalic));
	
	float3 SpecularColor =  GetSp(Normal, LightDir, EyeVec, RoughnessA, F0)*LightColor* SpecularAlbedo*ShadowRate.r;




	
	
	float ENDotR=max(0.0,2.0-dot(EyeVec,ND.xyz));
	
	
	
	
	SpecularColor+=tex2D(PLSpecularSamp,Tex)* SpecularAlbedo;
	
	
	Color.rgb=SpecularColor;

	return Color;
}

float4 PS_TotalKrSSL(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SpecularSamp,Tex);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	Color.rgb +=tex2D(SSSSamp,Tex)*Albedo.rgb;

	Color.rgb = pow(Color.rgb, 1.0/2.2);

	Color.rgb = min(5.0,max(0.0,Color.rgb));
	return Color;
}







technique FILTER <
	string Script =
	
	"RenderColorTarget0=DiffuseMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Diffuse;"

	"RenderColorTarget0=SSSMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSS;"
	

	"RenderColorTarget0=SpecularMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Specular;"
	
	"RenderColorTarget0=TotalKrSSLMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=TotalKrSSL;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ScriptExternal=Color;"

	;

> {
	pass Diffuse < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Diffuse();
	}
	pass SSS < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSS();
	}
	pass Specular < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Specular();
	}
	pass TotalKrSSL < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_TotalKrSSL();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
