///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

#define SAMPNUMGI 8
#define SAMPNUMGISS 8

float Si10 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float X : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float Y : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float Z : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;

static float SSGIRate=Si10;
static float SSGILumiRate=8.0+X;
static float SSGIOffFlag=Y;


float4x4 ViewMatrix      : VIEW;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);



float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(1, 1) / ViewportSize);
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560;


float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);


shared texture2D SPAMapRT: OFFSCREENRENDERTARGET ;
sampler SPASamp = sampler_state {
	Texture = ( SPAMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


shared texture2D LumiMap : RENDERCOLORTARGET;
sampler2D LumiSamp = sampler_state {
	texture = <LumiMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D AlbedoMap : RENDERCOLORTARGET ;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};




texture2D BeforeGIMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D BeforeGISamp = sampler_state {
	texture = <BeforeGIMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D SSGIMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSGISamp = sampler_state {
	texture = <SSGIMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D GIB1Map : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D GIB1Samp = sampler_state {
	texture = <GIB1Map>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
shared texture2D GIBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D GIBSamp = sampler_state {
	texture = <GIBMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};




texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}


float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);
	
	return N;

}

float4 PS_BeforeGI(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp,Tex);
	Color.rgb+=tex2D(LumiSamp,Tex).rgb*SSGILumiRate;
	Color.rgb*=SSGIRate;
	return Color;
}
float3 GetGIRate(float3 BaseNormal,float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float StartAddScale)
{
	//float Rate = 0;
	float2 STex = Tex - TexAdd*StartAddScale;
	float2 TexF=Tex;
	float VGMax=0;
	float VGS=0;
	float3 Normal2=normalize(BaseNormal+Normal);
	float3 GIColorT=0;
	[unroll]
	for (int R = 1; R <= SAMPNUMGI; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float4 AONormal = tex2D(NormalDepthSamp, STex.xy);
		float3 Gap=(AOWPos.xyz - WPos.xyz);
		float VG = max(0.0,max(0.0,dot(normalize(Gap),Normal))*max(0.0,dot(-normalize(Gap),AONormal)))/(1.0+length(Gap));
		GIColorT+=tex2D(BeforeGISamp, STex)*VG;
	}
	float3 GIColor=GIColorT/SAMPNUMGI;///VGS;
	
	
	return GIColor;
}


float4 PS_SSGI(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	////////////////////////////////////////////////////////////////////////////////////
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	float3 NoiseColor = noise3(WPos.xyz*100)*0; 
	float3 NoiseColor2 = noise3(WPos.xyz*100+1000)*0.2;
	float3 NoiseColor3 = noise3(WPos.xyz*100+2000)*0.4;
	float3 NoiseColor4 = noise3(WPos.xyz*100+3000)*0.6;
	
	float SSGINScale=6.4;
	float3 SSGINormal=normalize(Normal+NoiseColor)*SSGINScale;
	float3 SSGIPos = WPos.xyz + SSGINormal.xyz;
	float4 SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	float2	SSGITexAdd = (SSGITex.xy - Tex.xy);
	float3 GIColor = GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0);
	
	SSGINormal=normalize(Normal-NoiseColor)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.125);
	
	SSGINormal=normalize(Normal+NoiseColor2)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.25);
	
	SSGINormal=normalize(Normal-NoiseColor2)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.375);
	
	SSGINormal=normalize(Normal+NoiseColor3)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.5);
	
	SSGINormal=normalize(Normal-NoiseColor3)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.625);
	
	
	SSGINormal=normalize(Normal+NoiseColor4)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.75);
	
	SSGINormal=normalize(Normal-NoiseColor4)*SSGINScale;
	SSGIPos = WPos.xyz + SSGINormal.xyz;
	SSGITex = mul(float4(SSGIPos, 1.0), ViewProjMatrix);
	SSGITex.x = (1.0f + SSGITex.x / SSGITex.w) * 0.5f;
	SSGITex.y = (1.0f - SSGITex.y / SSGITex.w) * 0.5f;
	//float2	SSGITexAdd = normalize(SSGITex.xy - Tex.xy) /160;
	SSGITexAdd = (SSGITex.xy - Tex.xy);
	GIColor += GetGIRate(Normal,SSGINormal, Tex, SSGITexAdd, WPos, 0.875);
	

	Color.rgb=GIColor.rgb/8*min(1.0,pow(Depth*0.1,2)*(length(scaleProj)+0.1));
	return Color;
}


////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_GIB1(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp,Tex);
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	
	float2 STexSampA = SampStep2*8;
	float2 stexAdd = 0;
	float3 FColor = 0;
	float VGT = 0;
	
	
	
	[unroll]
	for (int ix =-SAMPNUMGISS; ix <= SAMPNUMGISS; ix++) {
	for (int iy = -SAMPNUMGISS; iy <= SAMPNUMGISS; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		float VG=saturate(1.0-distance(GIND.xyz,ND.xyz)*4-pow((GIND.a-ND.a),2));
		
		float3 SColor2 = tex2D(SSGISamp, Stex).rgb;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	
	
	FColor /= VGT;	
	Color.rgb=FColor;
	
	return Color;
}
float4 PS_GIB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp,Tex);
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	
	float2 STexSampA = SampStep2*4;
	float2 stexAdd = 0;
	float3 FColor = 0;
	float VGT = 0;
	
	[unroll]
	for (int ix =-SAMPNUMGISS; ix <= SAMPNUMGISS; ix++) {
	for (int iy = -SAMPNUMGISS; iy <= SAMPNUMGISS; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		float VG=saturate(1.0-distance(GIND.xyz,ND.xyz)*4-pow((GIND.a-ND.a),2));
		
		float3 SColor2 = tex2D(GIB1Samp, Stex).rgb;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	
	
	FColor /= VGT;	
	FColor=lerp(FColor,0.0,step(tex2D(SPASamp,Tex).a,0.0)*SSGIOffFlag);
	Color.rgb=FColor;//*tex2D(AlbedoSamp,Tex).rgb;
	
	return Color;
}

technique SSAO <
	string Script =


	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=BeforeGIMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=BeforeGI;"
	
	"RenderColorTarget0=SSGIMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSGI;"
	
	"RenderColorTarget0=GIB1Map;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=GIB1;"
	
	"RenderColorTarget0=GIBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=GIB;"
	;

> {
	pass BeforeGI < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_BeforeGI();
	}
	pass SSGI < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSGI();
	}
	pass GIB1 < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_GIB1();
	}
	pass GIB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_GIB();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
