///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

float Si10 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float X : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float Y : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float Z : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;

static float TestRate=1.0-Tr;

static float SSAORate=Si10*0.1;
static float MulRate=X;
static float CanselRate=0.5+Rx*180/3.14;

#define SAMPNUMSSAO 16
#define SAMPNUM 8


float4x4 ViewMatrix      : VIEW;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(0.5, 0.5) / ViewportSize);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);

shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET ;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D AlbedoMap : RENDERCOLORTARGET ;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};



texture2D SSMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "R16F";
>;
sampler2D SSSamp = sampler_state {
	texture = <SSMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};




texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



float GetAORate2(float3 BaseNormal,float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float StartAddScale,float3 EyeVec)
{
	float Rate = 0;
	float2 STex = Tex - TexAdd*StartAddScale;
	float VGS=0;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		
		float3 Gap=(AOWPos - WPos.xyz);
		
		float VG = max(0.0,(2.0-(distance(normalize(Gap), BaseNormal)))/(2.0+length(Gap)*0.2));
		VGS=max(VGS,VG);
	}
	//Rate = saturate(Rate/ SAMPNUMSSAO);
	Rate=VGS;
	return Rate;
}
float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);
	
	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passSS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	
	float3 NoiseColor = (noise3(WPos.xyz*100))*0.5;
	float3 NoiseColor2 = (noise3(100-WPos.xyz*100))*0.5;
	float3 NoiseColor3 = (noise3(120+WPos.xyz*100))*0.6;
	float3 NoiseColor4 = (noise3(-200-WPos.xyz*100))*0.7;
	float3 NoiseColor5 = (noise3(WPos.xyz*100+10))*0.3;
	float3 NoiseColor6 = (noise3(200-WPos.xyz*100))*0.35;
	float3 NoiseColor7 = (noise3(220+WPos.xyz*100))*0.4;
	
	
	float SSAONScale=0.5;
	
	
	float3 SSAONormal=normalize(Normal+NoiseColor);
	float3 SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	float4 SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	float2	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	float SSAORate2 = 0;
	float GIAORate1 = GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0,EyeVec);
	
	SSAONormal=normalize(Normal+NoiseColor2);
	SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	GIAORate1 += GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0.15,EyeVec);

	SSAONormal=normalize(Normal+NoiseColor3);
	SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	GIAORate1 += GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0.3,EyeVec);
	
	SSAONormal=normalize(Normal+NoiseColor4);
	SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	GIAORate1 += GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0.45,EyeVec);

	SSAONormal=normalize(Normal+NoiseColor5);
	SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	GIAORate1 += GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0.6,EyeVec);

	SSAONormal=normalize(Normal+NoiseColor6);
	SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	GIAORate1 += GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0.75,EyeVec);
	
	SSAONormal=normalize(Normal+NoiseColor7);
	SSAOPos = WPos.xyz + SSAONormal.xyz*SSAONScale;
	SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	SSAOTexAdd = SSAOTex.xy - Tex.xy;
	GIAORate1 += GetAORate2(Normal,SSAONormal, Tex, SSAOTexAdd, WPos, 0.9,EyeVec);
	
	
	
	
	float GIAORate =  saturate(1.0 - (GIAORate1/7-CanselRate)*SSAORate);

	Color.r = GIAORate;
	///////////////////////////////////////////////////////////////////////////////////////////////////

	return Color;

}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passDraw(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp,Tex);
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float3 Albedo = tex2D(AlbedoSamp, Tex).rgb;

	//float2 STexSampA = SampStep * 12* ViewportSize.y/1080;
	float2 stexAdd = 0;
	float FColor = 0;
	float VGT = 0;


	float2 SampStepRate = SampStep*4;
	[unroll]
	for (int ix =-SAMPNUM; ix <= SAMPNUM; ix++) {
	for (int iy = -SAMPNUM; iy <= SAMPNUM; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ SampStepRate*AddTexB;
		
		//float3 AOWPos = tex2D(WPosSamp, Stex);
		//float VG = saturate(1.0 - pow(distance(AOWPos.xyz, WPos.xyz),2) *32/ min(4, max(1.0, Depth*0.1)));

		float3 AOAlbedo = tex2D(AlbedoSamp, Stex);
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG = saturate(1.0 -distance(AOAlbedo.xyz, Albedo.xyz));
		VG *=saturate(1.0-distance(AONormal.xyz, Normal.xyz));
		VG *=saturate(1.0-distance(AONormal.a, Depth)*0.1);

		
		float3 SColor2 = tex2D(SSSamp, Stex).rgb;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}

	FColor /= VGT;	
	
	FColor=lerp(FColor,1.0,step(tex2D(MaterialKrSSLSamp,Tex).a,0.0));
	//FColor=tex2D(SSSamp, Tex).r;
	
	float3 MulColor=Color.rgb*lerp(normalize(pow(Color.rgb,2)),1.0,FColor);
	
	
	Color.rgb=lerp(Color.rgb*FColor,MulColor,MulRate);
	Color.rgb=lerp(Color.rgb,FColor,TestRate);
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique SSAO <
	string Script =


	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=SSMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=SS;"

	
	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Draw;"
	
	;

> {
	pass SS < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passSS();
	}
	pass Draw < string Script = "Draw=Buffer;"; > {
		//AlphaBlendEnable = FALSE;
		//AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passDraw();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
