///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;


float SRainRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "J"; >;

#define SAMPNUMSSR 128
#define SAMPNUM 8

static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
float Si : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
static float SSRRate=Si*0.1;

float4x4 ViewMatrix      : VIEW;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(0.5, 0.5) / ViewportSize);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);

shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET ;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


shared texture2D AlbedoMap : RENDERCOLORTARGET;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET ;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D SSMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSSamp = sampler_state {
	texture = <SSMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};




texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



float3 GetSSRRate2(float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float3 EyeVec, float StartAddScale,float Roughness)
{
	float Rate =0.0;
	float Rate2 =0.0;
	float2 FinalTex = Tex;

	float2 STex = Tex - TexAdd*StartAddScale;
	float3 SSRColor = 0;//tex2D(SSSSamp, STex);
	float NEDot=dot(Normal, -EyeVec)*0.8;
	//float RGain=SAMPNUMSSR;
	float DotStep=0.0;
	float VGPow=64*(2.0-Roughness);
	[unroll]
	for (int R = 1; R <= SAMPNUMSSR; R += 1) {

		STex += TexAdd;
		float4 SSRWPos = tex2D(WPosSamp, STex.xy);

		float3 Gap = (SSRWPos.xyz - WPos.xyz);
		//float GEDot=dot(normalize(Gap),-EyeVec);
		//DotStep+=step(GEDot,NEDot)/R;
		//float VG =saturate(distance(normalize(Gap), Normal.xyz)-Rate/R-DotStep);

		float3 NGap = normalize(Gap);
		//float VG = max(0.0,dot(NGap,Normal)-Rate/R-DotStep);
		float VG = max(0.0,dot(NGap,Normal));
		VG = pow(VG,VGPow);
		//VG = pow(VG,(SAMPNUMSSR-R+1.0)*(2.0-Roughness));
		//VG = max(0.0,VG-(Rate+DotStep));
		VG = max(0.0,VG-Rate-NEDot);
		SSRColor += tex2D(ScnSamp, STex.xy)*VG;
		Rate += VG;	

	}

	//SSRColor = tex2D(SSSSamp,  FinalTex);


	SSRColor /= max(1.0,Rate);//SAMPNUMSSR;

	return SSRColor;
}
float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);
	
	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passSS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMSS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	float3 NoiseColor = noise3(WPos.xyz*100)*0.00; 
	float3 SSRNormal = normalize(reflect(-EyeVec, normalize(Normal+NoiseColor*Roughness)));

	float3 SSRPos = WPos.xyz + SSRNormal.xyz;

	float4 SSRTex = mul(float4(SSRPos, 1.0), ViewProjMatrix);
	SSRTex.x = (1.0f + SSRTex.x / SSRTex.w) * 0.5f;
	SSRTex.y = (1.0f - SSRTex.y / SSRTex.w) * 0.5f;
	
	float2 SSRTexAdd = normalize(SSRTex.xy - Tex.xy) / SAMPNUMSSR*(0.5+length(Tex.xy-0.5)*0.5);


	float3 SSRRate1 = GetSSRRate2(SSRNormal, Tex, SSRTexAdd, WPos,EyeVec, 0.0,Roughness)*saturate(0.9-dot(EyeVec,SSRNormal));
	
	Color.rgb=SSRRate1.rgb;
	///////////////////////////////////////////////////////////////////////////////////////////////////

	return Color;

}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passDraw(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp,Tex);
	
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMSS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float3 Albedo = tex2D(AlbedoSamp, Tex).rgb;

	//float2 STexSampA = SampStep * 12* ViewportSize.y/1080;
	float2 stexAdd = 0;
	float3 FColor = 0;
	float VGT = 0;


	float2 SampStepRate = SampStep*4*Roughness;
	[unroll]
	for (int ix =-SAMPNUM; ix <= SAMPNUM; ix++) {
	for (int iy = -SAMPNUM; iy <= SAMPNUM; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ SampStepRate*AddTexB;
		
		//float3 AOWPos = tex2D(WPosSamp, Stex);
		//float VG = saturate(1.0 - pow(distance(AOWPos.xyz, WPos.xyz),2) *32/ min(4, max(1.0, Depth*0.1)));

		float3 AOAlbedo = tex2D(AlbedoSamp, Stex);
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG = saturate(1.0 -distance(AOAlbedo.xyz, Albedo.xyz));
		VG *=saturate(1.0-distance(AONormal.xyz, Normal.xyz));
		VG *=saturate(1.0-distance(AONormal.a, Depth)*0.1);

		
		float3 SColor2 = tex2D(SSSamp, Stex).rgb;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}

	FColor /= VGT;	
	
	
	float3 SpecularAlbedo = lerp(Specular, Albedo.rgb, saturate(Metalic));
	Color.rgb+=FColor*SpecularAlbedo*saturate((0.75- Roughness)/0.75+Metalic)*SSRRate;
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique SSAO <
	string Script =


	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=SSMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=SS;"

	
	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Draw;"
	
	;

> {
	pass SS < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passSS();
	}
	pass Draw < string Script = "Draw=Buffer;"; > {
		//AlphaBlendEnable = FALSE;
		//AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passDraw();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
