///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

float time : TIME;
static float Roughness=0.2;
static float RoughnessA=pow(Roughness,2);
static float Metalic=0.0;
static float Specular=0.5;
static float F0=0.9;
static float ReflactSize=0.05;
static float3 WaterAlbedo=float3(0.1,0.2,0.5);
float Ry : CONTROLOBJECT < string name = "(self)"; string item = "Ry"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;
static float Speed=(1.0+Rx*180/3.14);
#define ScnScale 1.0


#define SAMPNUMSSR 128
#define SAMPNUM 8

static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
float Si : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
static float SSRRate=Si*0.1;

float4x4 ViewMatrix      : VIEW;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(0.5, 0.5) / ViewportSize);


float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);


float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;
float ClearDepth = 1.0;
float4 ClearColor= float4(0,0,0,0);

texture WaterTex <
	string ResourceName = "Water/Water.png";
	int Miplevels = 1;
>;
sampler WaterSamp = sampler_state {
	texture = <WaterTex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MIPFILTER = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};

texture2D WaterKrss2lMapRT: OFFSCREENRENDERTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
string Description = "ގ蓖1";
string Format = "A32B32G32R32F";
float4 ClearColor = { 0, 0, 0, 0 };
float ClearDepth = 1.0;
bool AntiAlias = false;
int Miplevels = 1;
string DefaultEffect =
"self = hide;"
"WaterA.x =Water/Water.fx;"
"* = hide;"
;
>;
sampler WaterKrSSLSamp = sampler_state {
	Texture = (WaterKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


texture2D  WaterWPosKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D  WaterWPosSamp = sampler_state {
	texture = < WaterWPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D  WaterNormalDepthKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D  WaterNormalDepthSamp = sampler_state {
	texture = < WaterNormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};








shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET ;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


shared texture2D AlbedoMap : RENDERCOLORTARGET;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET ;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
texture2D SSRAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSRASamp = sampler_state {
	texture = <SSRAMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D SSRBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSRBSamp = sampler_state {
	texture = <SSRBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D BeforeDrawMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D BeforeDrawSamp = sampler_state {
	texture = <BeforeDrawMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}

float GetCWDisMS(float2 STexS,float EyeW)
{
 float CWDisMS=tex2D(WPosSamp,STexS).a-EyeW;
 float CWDisStep=step(CWDisMS,0.0);
 float2 R=CWDisMS*(1.0-CWDisStep*1.6);
 return R;
}

float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float dotLN = saturate(dot(LightDir, Normal));
	float Diffuse = dotLN;
	return Diffuse;
}
float GetSp(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA, float F0)
{
	float3 HalfVec = normalize(EyeVec + LightDir);
	float DotNL = max(0.00000001, saturate(dot(Normal, LightDir)));
	float DotNE = max(0.00000001, saturate(dot(Normal, EyeVec)));
	float DotNH = max(0.00000001, saturate(dot(Normal, HalfVec)));
	float DotEH = max(0.00000001, saturate(dot(EyeVec, HalfVec)));
	float DotLH = max(0.00000001, saturate(dot(LightDir, HalfVec)));

	float D = pow(RoughnessA, 2) / (3.14159265*pow(pow(DotNH, 2)*(pow(RoughnessA, 2) - 1) + 1, 2));
	float F = F0 + (1 - F0)*pow(1.0 - DotEH, 5);
	float G = min(1.0, min(2 * DotNH*DotNE / DotEH, 2 * DotNH*DotNL / DotEH));
	float Specular = F*D*G / (4 * DotNE*DotNL);// +0.0001);

	Specular = max(0.0, min(2.0, Specular));

	return Specular;
}

float3 GetSSRRate2(float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float3 EyeVec, float StartAddScale)
{
	float Rate =0.0;
	float Rate2 =0.0;
	float2 FinalTex = Tex;

	float2 STex = Tex - TexAdd*StartAddScale;
	float3 SSRColor = 0;//tex2D(ScnSamp, STex);
	float NEDot=dot(Normal, -EyeVec);
	float DotStep=0.0;
	float VGPow=64*(2.0);
	[unroll]
	for (int R = 1; R <= SAMPNUMSSR; R += 1) {

		STex += TexAdd;
		float4 SSRWPos = tex2D(WPosSamp, STex.xy);

		float3 Gap = (SSRWPos.xyz - WPos.xyz);

		float3 NGap = normalize(Gap);
		float VG = max(0.0,dot(NGap,Normal));
		VG = pow(VG,VGPow);
		VG = max(0.0,VG-Rate/R-NEDot);
		SSRColor += tex2D(ScnSamp, STex.xy)*VG;
		Rate += VG;	

	}


	SSRColor /= max(1.0,Rate);//SAMPNUMSSR;


	return SSRColor;
}
float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);
	
	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_WaterPosW(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = 1.0;
	float Depth = abs(tex2D(WaterKrSSLSamp,Tex).a);

	Depth=lerp(10000,Depth,step(0.00001,Depth));

	float2 PPos = (Tex - 0.5) * float2(2.0, -2.0);
	float3 VPos = float3(PPos.xy * scaleProj, 1) * Depth;
	Color.rgb = mul(float4(VPos, 1), InvViewMatrix).xyz;
	Color.a = distance(Color.rgb,CameraPosition);// Depth;


	return Color;
}
float4 PS_passBeforeDraw(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = 0.0;




	float3 WPos = tex2D(WPosSamp, Tex).xyz;


	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;

	//float3 WaterWPos = tex2D(WaterWPosSamp, Tex).xyz;
	//float4 WaterND = tex2D(WaterNormalDepthSamp, Tex);

	float WaterDepth = abs(tex2D(WaterKrSSLSamp,Tex).a);

	WaterDepth=lerp(10000,WaterDepth,step(0.00001,WaterDepth));

	float2 PPos = (Tex - 0.5) * float2(2.0, -2.0);
	float3 VPos = float3(PPos.xy * scaleProj, 1) * WaterDepth;
	float3 WaterWPos = mul(float4(VPos, 1), InvViewMatrix).xyz;




	float4 WaterND = tex2D(WaterKrSSLSamp, Tex);

	//float WaterDepth = WaterND.a;

	float3 WaterNormal =WaterND.xyz;
	float3 WaterEyeVec = -normalize(WaterWPos.xyz - CameraPosition);





	float EyeW=distance(WaterWPos,CameraPosition);

	float CWDis=distance(WPos.xyz,CameraPosition)-distance(WaterWPos.xyz,CameraPosition);
	

	clip(CWDis);
	
	float WaterAlpha=saturate(CWDis*(0.025+saturate(dot(WaterEyeVec,WaterNormal))*0.05));
	float FallRate=pow(length(WaterNormal.xz)*3,4)*2;
	
	float2 WaterTex=WaterWPos.xz*0.01+sin(+time*(3+FallRate*20)+WaterWPos.xz*0.5)*0.01;
	WaterTex+=sin(time*(5+FallRate*20)+WaterWPos.xz*0.2)*0.001;
	WaterTex.x+=-time*0.1*sin(Ry)*Speed;
	WaterTex.y+=-time*0.1*cos(Ry)*Speed;

	float4 NormalT1 = tex2D(WaterSamp, WaterTex);
	float3x3 tangentFrame = compute_tangent_frame(WaterNormal, WaterEyeVec, WaterTex);
	float3 eyeTangent = normalize(mul(WaterEyeVec, tangentFrame));
	float3 WaterNormal2 = normalize(mul(normalize(2.0f * saturate(NormalT1.rgb) - 1.0f), tangentFrame));
	WaterNormal=normalize(lerp(WaterNormal,WaterNormal2,0.5+FallRate));
	
	WaterTex=WaterWPos.xz*0.05+sin(time*(10+FallRate*20)+sin(time)+WaterWPos.xz+sin(WaterWPos.zx*10))*0.01;
	
	 NormalT1 = tex2D(WaterSamp, WaterTex);
	tangentFrame = compute_tangent_frame(WaterNormal, WaterEyeVec, WaterTex);
	eyeTangent = normalize(mul(WaterEyeVec, tangentFrame));
	WaterNormal2 = normalize(mul(normalize(2.0f * saturate(NormalT1.rgb) - 1.0f), tangentFrame));
	
	WaterNormal=normalize(lerp(WaterNormal,WaterNormal2,saturate(0.5-WaterAlpha*0.1+FallRate*2)));
	

	float2 STexH=Tex.xy;
	//float2 STexH=Tex.xy+WaterNormal.xz*0.1;
	//float2 STexH=WaterRfTex.xy;


	float CWDisMS=CWDis;
	float CWDisStep=step(0.0,CWDisMS);
	float CWDisMST=CWDisMS*CWDisStep;
	float CWDisStepT=CWDisStep;
	
	float2 SampStepWW=0;
	float StepWWS=SampStep*400/WaterDepth;
	
	[unroll]
	for (int i = 0; i <= 4; i++) {
	
	SampStepWW=StepWWS*i;
	
	float2 STexS=STexH+float2(SampStepWW.x,SampStepWW.y);
	float CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	
	STexS=STexH+float2(SampStepWW.x,-SampStepWW.y);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	STexS=STexH+float2(-SampStepWW.x,SampStepWW.y);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	STexS=STexH+float2(-SampStepWW.x,-SampStepWW.y);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	
	STexS=STexH+float2(SampStepWW.x,0);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	
	STexS=STexH+float2(-SampStepWW.x,0);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	
	STexS=STexH+float2(0,-SampStepWW.y);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	
	STexS=STexH+float2(0,SampStepWW.y);
	CWK=GetCWDisMS(STexS,EyeW);
	CWDisMST=min(CWK,CWDisMST);
	
	}
	
	
	float HitRate=saturate(saturate(1.0-CWDisMST*0.5));
	
	
	
	
	
	
	
	WaterTex=WaterWPos.xz*0.01+sin(time*2+HitRate*4)*0.02;
	
	 NormalT1 = tex2D(WaterSamp, WaterTex);
	tangentFrame = compute_tangent_frame(WaterNormal, WaterEyeVec, WaterTex);
	eyeTangent = normalize(mul(WaterEyeVec, tangentFrame));
	WaterNormal2 = normalize(mul(normalize(2.0f * saturate(NormalT1.rgb) - 1.0f), tangentFrame));
	
	WaterNormal=normalize(lerp(WaterNormal,WaterNormal2,HitRate));

	float3 WaterRfWPos=WaterWPos+refract(WaterEyeVec,WaterNormal,1.0)*max(0.0,Depth-WaterDepth)*0.1;
	float4 WaterRfTex = mul(float4(WaterRfWPos, 1.0), ViewProjMatrix);
	WaterRfTex.x = (1.0f + WaterRfTex.x / WaterRfTex.w) * 0.5f;
	WaterRfTex.y = (1.0f - WaterRfTex.y / WaterRfTex.w) * 0.5f;


	float DiffuseRate=GetDif(WaterNormal, LightDir, WaterEyeVec, RoughnessA);
	float Dif=DiffuseRate;//*ShadowRate.r;
	float3 TotalDiffuseColor=Dif*LightColor/ 3.141592;
	Color.rgb=WaterAlbedo*TotalDiffuseColor*(1.0-Metalic);
	float3 SpecularAlbedo = lerp(Specular, WaterAlbedo, saturate(Metalic));
	
	float3 SpecularColor =  GetSp(WaterNormal, LightDir, WaterEyeVec, RoughnessA, F0)*LightColor* SpecularAlbedo;//*ShadowRate.r;

	Color.rgb+=SpecularColor;

	Color.rgb = pow(Color.rgb, 1.0/2.2);




	WaterAlpha=saturate(CWDis*(0.002+saturate(dot(WaterEyeVec,WaterNormal))*0.1));
	
	//float2 STexN=Tex.xy+CWDis*min(1.0/Depth,ReflactSize*WaterAlpha)/(1.0+pow(WaterDepth,2)*0.001);
	//float2 STexN=Tex.xy+CWDis*min(1.0/Depth,ReflactSize*WaterAlpha)/(1.0+pow(WaterDepth,2)*0.001);



	float WWWDis=step(distance(tex2D(WPosSamp,WaterRfTex).xyz,CameraPosition),distance(WaterWPos.xyz,CameraPosition));
	float2 STexN=lerp(WaterRfTex,Tex.xy,saturate(WWWDis));


	//float WaterAlpha2=saturate(CWDis*(0.005+saturate(dot(WaterEyeVec,WaterNormal))*0.05));
	
	
	
	//WaterAlpha=lerp(WaterAlpha,WaterAlpha2,step(EyeW,WNA));


	
	//Color.rgb=lerp(Color.rgb,0.1*LightColor,saturate(FallRate+saturate(1.0-dot(Normal,float3(0.0,1.0,0.0)))));
	
	Color.rgb=lerp(Color.rgb,tex2D(ScnSamp,STexN).rgb,saturate(1.0-WaterAlpha));
	
	//Color.rgb=lerp(Color.rgb,normalize(LightColor)*min(1.2,length(LightColor)),saturate(HitRate*0.5)*saturate(WaterAlpha*10));
	Color.rgb=Color.rgb+normalize(LightColor)*min(1.2,length(LightColor)*0.1)*saturate(HitRate*0.5)*saturate(WaterAlpha*10);

	

	
	//Color.a=Albedo.a;
	


	Color.rgb=(trunc(Color.rgb*100)+abs(WaterNormal*0.99))*(step(0.0,WaterNormal)*2.0-1.0);
	Color.a=1.0;



	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_WaterND(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(BeforeDrawSamp, Tex);
	ND.rgb = normalize(fmod(ND.rgb, 1.0));
	float Depth = abs(tex2D(WaterKrSSLSamp,Tex).a);

	return ND;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passSSRA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float3 WaterWPos = tex2D(WaterWPosSamp, Tex).xyz;
	float4 WaterND = tex2D(WaterNormalDepthSamp, Tex);
	float WaterDepth = WaterND.a;
	float3 WaterNormal =WaterND.xyz;


	float CWDis=distance(WPos,CameraPosition)-distance(WaterWPos,CameraPosition);
	clip(CWDis);
	clip(length(WaterNormal)-0.1);

	float3 WaterEyeVec = -normalize(WaterWPos.xyz - CameraPosition);
	
	float3 NoiseColor = noise3(WaterWPos.xyz*100)*0.01; 
	float3 SSRNormal = normalize(reflect(-WaterEyeVec, normalize(WaterNormal+NoiseColor)));

	float3 SSRPos = WaterWPos.xyz + SSRNormal.xyz;

	float4 SSRTex = mul(float4(SSRPos, 1.0), ViewProjMatrix);
	SSRTex.x = (1.0f + SSRTex.x / SSRTex.w) * 0.5f;
	SSRTex.y = (1.0f - SSRTex.y / SSRTex.w) * 0.5f;
	
	float2 SSRTexAdd = normalize(SSRTex.xy - Tex.xy) / SAMPNUMSSR*(0.5+length(Tex.xy-0.5)*0.5);


	float3 SSRRate1 = GetSSRRate2(SSRNormal, Tex, SSRTexAdd, WaterWPos,WaterEyeVec, 0.0)*saturate(0.9-dot(WaterEyeVec,SSRNormal));
	
	Color.rgb=SSRRate1.rgb;
	///////////////////////////////////////////////////////////////////////////////////////////////////

	return Color;

}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passSSRB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ColorScn = tex2D(ScnSamp,Tex);

	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float3 WaterWPos = tex2D(WaterWPosSamp, Tex).xyz;
	float4 WaterND = tex2D(WaterNormalDepthSamp, Tex);
	float WaterDepth = WaterND.a;
	float3 WaterNormal =WaterND.xyz;

	float CWDis=distance(WPos,CameraPosition)-distance(WaterWPos,CameraPosition);
	clip(CWDis);
	clip(length(WaterNormal)-0.1);

	float4 Color = 1.0;
	



	//float2 STexSampA = SampStep * 12* ViewportSize.y/1080;
	float2 stexAdd = 0;
	float3 FColor = tex2D(SSRASamp, Tex).rgb;
	float VGT = 1;

	float2 SampStepRate = SampStep;
	[unroll]
	for (int ix =-SAMPNUM; ix <= SAMPNUM; ix++) {
	for (int iy = -SAMPNUM; iy <= SAMPNUM; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ SampStepRate*AddTexB;
		
		//float3 AOWPos = tex2D(WPosSamp, Stex);
		//float VG = saturate(1.0 - pow(distance(AOWPos.xyz, WPos.xyz),2) *32/ min(4, max(1.0, Depth*0.1)));


		float4 AONormal = tex2D(WaterNormalDepthSamp, Stex);
		float VG =saturate(1.0-distance(AONormal.xyz, WaterNormal.xyz)*2);
		VG *=saturate(1.0-distance(AONormal.a, Depth)*0.1);

		
		float3 SColor2 = tex2D(SSRASamp, Stex).rgb;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}

	FColor /= VGT;	
	
	

	Color.rgb=FColor;


	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

float4 PS_passDraw(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp,Tex);
	float4 BColor = tex2D(BeforeDrawSamp,Tex);
	BColor.rgb = trunc(abs(BColor.rgb))*0.01;

	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float3 WaterWPos = tex2D(WaterWPosSamp, Tex).xyz;

	float CWStep=step(distance(WaterWPos,CameraPosition),distance(WPos,CameraPosition));

	Color.rgb = lerp(Color.rgb,BColor.rgb,CWStep);


	float CWGat=saturate((distance(WPos,CameraPosition)-distance(WaterWPos,CameraPosition))*0.3);
	Color.rgb += tex2D(SSRBSamp,Tex).xyz*CWGat;


	//Color.rgb =tex2D(WaterNormalDepthSamp, Tex)*0.5+0.5;






	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
technique SSAO <
	string Script =


	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=WaterWPosKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=WaterPosW;"



	"RenderColorTarget0=BeforeDrawMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=BeforeDraw;"

	"RenderColorTarget0=WaterNormalDepthKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=WaterND;"


	"RenderColorTarget0=SSRAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=SSRA;"

	"RenderColorTarget0=SSRBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=SSRB;"
	
	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Draw;"
	
	;

> {	pass WaterPosW < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_WaterPosW();
	}
	pass BeforeDraw < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passBeforeDraw();
	}
	pass WaterND < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_WaterND();
	}
	pass SSRA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passSSRA();
	}
	pass SSRB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passSSRB();
	}
	pass Draw < string Script = "Draw=Buffer;"; > {
		//AlphaBlendEnable = FALSE;
		//AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passDraw();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
