float time : TIME;
static float Roughness=0.2;
static float RoughnessA=pow(Roughness,2);
static float Metalic=0.0;
static float Specular=0.5;
static float F0=0.9;
static float ReflactSize=0.2;






// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 ProjMatrix		: PROJECTION;



float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
static float3 SpecularColor = MaterialSpecular * LightSpecular;


// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = (float2(0.5, 0.5) / ViewportSize);
static float2 SampStep = (float2(0.5, 0.5) / ViewportSize);
// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};



float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);


float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;



///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
	float4 Pos      : POSITION;
	float3 Eye    	: TEXCOORD0;
	float2 Tex	    : TEXCOORD1;
	float4 PosW     : TEXCOORD2;
	float3 Normal   : TEXCOORD3;
	float3 Eye2     : TEXCOORD4;
////////////KrShadowǉ/////////////////
	float4 ScreenTex: TEXCOORD5;
////////////KrShadow܂Œǉ///////////////
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;


	Out.PosW = mul(Pos, WorldMatrix);

	Out.Normal = normalize(mul(Normal, (float3x3)WorldMatrix));

	Out.Pos = mul(Out.PosW,ViewProjMatrix);

	Out.Eye = mul(Out.PosW, ViewMatrix);
////////////KrShadowǉ/////////////////
	Out.ScreenTex = Out.Pos;
////////////KrShadow܂Œǉ///////////////
	Out.Tex = Tex;


	Out.Eye2 = CameraPosition-Out.PosW.xyz;

	return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN, float VFace : VFACE,uniform bool useTexture) : COLOR0
{
	float4 Color = 1.0;
	Color.rgb = MaterialEmmisive+ MaterialDiffuse.rgb;
	//Color.a *=MaterialDiffuse.a;
	float4 Albedo=Color;
	if ( useTexture ) {
	float4 TexColor = tex2D(ObjTexSampler, IN.Tex);
	TexColor.rgb = pow(TexColor.rgb, 2.2);
	Albedo *= TexColor;
    }
	float3 Normal=IN.Normal*VFace;
	Color.rgb=Normal;
	Color.a=IN.Eye.z;

	return Color;
}

// IuWFNg`peNjbN
technique MainTec < string MMDPass = "object"; bool UseTexture = true;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTec2 < string MMDPass = "object"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
// IuWFNg`peNjbN
technique MainTecBS  < string MMDPass = "object_ss"; bool UseTexture = true;> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTecBS2 < string MMDPass = "object_ss"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}
technique ZplotTec	< string MMDPass = "zplot"; >{

}

///////////////////////////////////////////////////////////////////////////////////////////////