///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;
///////////////////////////////////////////////////////////////////////////////////



#define ScnScale 1.0

static float AABlurScale=0.5;
static float AAScale=0.0;

#define SAMPNUMSSAO2 32
#define SAMPNUMS 16
#define SAMPNUMS2 8
#define SAMPNUMSS 16
#define SAMPNUMSS2 8
#define SAMPNUMAA 16


static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
//e

float3 SkyColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = ""; >;
float3 GroundColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "nʊ"; >;
float EnvDefColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "0"; >;
float EnvAllColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "S0"; >;
float SRainRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "J"; >;

static float3 SkyColor=(0.05*(1.0-EnvDefColor0)+SkyColor1)*LightColor*(1.0-EnvAllColor0);
static float3 GroundColor=(0.05*(1.0-EnvDefColor0)+GroundColor1)*LightColor*(1.0-EnvAllColor0);


///////////////////////////////////////////////////////////////////////////////////
float4x4 SMat: CONTROLOBJECT < string name = "(self)"; >;
static float3 SPos = float3(SMat._41, SMat._42, SMat._43);
float ShSi2 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;

static float ShSi = ShSi2*0.1;

float3    LightDirL1   : DIRECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;

static float3 PosL = SPos  - LightDirection * 3000;


float4 GetLightPos(float3 WPos)
{

	float LYZFlag = step(0.999, pow(LightDirection.y, 2));

	float3 LCrossX = normalize(cross(LightDirection, float3(0.0, LYZFlag, 1.0 - LYZFlag)));

	float3 LCrossY = normalize(cross(LightDirection, LCrossX));

	float4 XYZ = 0;

	float3 WLL=(WPos - PosL);
	XYZ.z = dot(LightDirection, WLL);
	XYZ.x = dot(LCrossX, WLL);
	XYZ.y = dot(LCrossY, WLL);

	XYZ.xy /= 256 * ShSi;


	XYZ.z = (XYZ.z - 500) / (6000 - 500);


	XYZ.w = 1;
	return XYZ;
}





shared texture KrSSLiteShaMapRT: OFFSCREENRENDERTARGET <
	string Description = "LS";
	int Width =4096;
	int Height =4096;
	string Format = "R32F";
	float4 ClearColor = { 10000, 0, 0, 0 };
	float ClearDepth = 1.0;
	bool AntiAlias = false;//true;
	int Miplevels = 1;
	string DefaultEffect =
		"self = hide;"
		"* = ShadowMap/ShadowMap.fx;";
>;
sampler2D KrSSLiteShaSamp = sampler_state {
	texture = <KrSSLiteShaMapRT>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
static float2 SSampStep =0.5 / 4096;

///////////////////////////////////////////////////////////////////////////////////
//e܂1

float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(1, 1) / ViewportSize);
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);



shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
string Description = "ގ蓖1";
string Format = "A32B32G32R32F";
float4 ClearColor = { 0, 0, 0, 0 };
float ClearDepth = 1.0;
bool AntiAlias = false;
int Miplevels = 1;
string DefaultEffect =
"self = hide;"
"* =Material/Base/Material.fx;";
>;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



shared texture2D WPosKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D AlbedoMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

texture2D DirShadowAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowASamp = sampler_state {
	texture = <DirShadowAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D DirShadowBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowBSamp = sampler_state {
	texture = <DirShadowBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D LumiMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D LumiSamp = sampler_state {
	texture = <LumiMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	string Format = "D24S8";
>;

float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);

	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_MatA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	float3 Mat = fmod(trunc(abs(Color.rgb))*0.01,1.0);
	float3 Mat2 = fmod(trunc(trunc(abs(Color.rgb))*0.01),10.0)*0.1;
	float4 RMSS = float4(Mat,Mat2.x);

	return RMSS;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_ND(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(MaterialKrSSLSamp, Tex);
	ND.rgb = normalize(fmod(ND.rgb, 1.0));
	ND.a=abs(ND.a);
	return ND;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Albedo(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	
	Color.rgb = trunc(abs(Color.rgb)*0.001)*0.01;
	
	Color.a=1.0;
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Lumi(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	
	Color.rgb = trunc(abs(Color.rgb)*0.001)*0.01;
	
	Color.rgb=normalize(Color.rgb)*max(0.0,length(Color.rgb)-2);
	Color.a=1.0;
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_PosW(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = 1.0;
	float Depth = abs(tex2D(MaterialKrSSLSamp, Tex).a);

	Depth=lerp(10000,Depth,step(0.00001,Depth));

	float2 PPos = (Tex - 0.5) * float2(2.0, -2.0);
	float3 VPos = float3(PPos.xy * scaleProj, 1) * Depth;
	Color.rgb = mul(float4(VPos, 1), InvViewMatrix).xyz;
	Color.a = distance(Color.rgb,CameraPosition);// Depth;


	return Color;
}
float GetAORate(float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float StartAddScale)
{
	float Rate = 0;
	float2 STex = Tex - TexAdd*StartAddScale;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO2; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos.xyz - WPos.xyz);
		float VG = saturate(1.0 - distance(normalize(Gap), Normal.xyz)*5);

		Rate += VG;
	}
	//Rate = saturate(Rate/SAMPNUMSSAO2*16);
	Rate = saturate(Rate/SAMPNUMSSAO2*16);
	return Rate;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float4 WPos = tex2D(WPosSamp, Tex);
	WPos.a = 1.0;
	float3 Normal = ND.rgb;
	float Depth = ND.a;
	float4 Color = 1.0;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float RFlag=step(1.5,Mat2.y)*step(Mat2.y,2.5);
	float RFlag2=RFlag*saturate(pow(dot(LightDir,-Normal),2)+(max(0.0,dot(LightDir,-EyeVec))*0.13));
	float3 Normal2=normalize(lerp(Normal,LightDir,RFlag2));
	



	Color.r = saturate((dot(LightDir, Normal2)) * 80);
	float4 ZCalcTex= GetLightPos(WPos.xyz);

	// eNX`Wɕϊ
	ZCalcTex /= ZCalcTex.w;
	float ZTexLength=length(ZCalcTex.xy);
	float2 TransTexCoord;
	TransTexCoord.x = (1.0f + ZCalcTex.x)*0.5f;
	TransTexCoord.y = (1.0f - ZCalcTex.y)*0.5f;

	
	float SCor =length(scaleProj)+min(5.0, Depth*0.002);
	float SCorS =6000.0;
	
	float SSRate = saturate(max(ZCalcTex.z - tex2D(KrSSLiteShaSamp, TransTexCoord).a, 0.0f) *SCorS - SCor);
	float2 SSampStep2=SSampStep;
	
	
	[unroll]
	for (int ix =-SAMPNUMS2; ix <= SAMPNUMS2; ix++) {
	for (int iy = -SAMPNUMS2; iy <= SAMPNUMS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = TransTexCoord+ SSampStep2*AddTexB;
	
		float SColor= tex2D(KrSSLiteShaSamp, Stex).r;
		SSRate+=saturate(max(ZCalcTex.z - SColor, 0.0f)*SCorS - SCor);

	}
	}
	
	SSRate = 1.0 - saturate(SSRate / pow(SAMPNUMS2*2 + 1,2)*4);

	float TexFlag=saturate(pow((length(TransTexCoord.xy-0.5))*2,2)-0.75)*4;

	Color.r *=  saturate(SSRate+TexFlag);
	
	float LSSize=0.02;//(0.02 + max(0.0,Depth*0.002 - 0.5));
	float3 L2Normal = normalize(lerp(-LightDirection, Normal , 0.1));
	float3 DOPos = WPos.xyz + L2Normal*LSSize;
	float4 DOTex = mul(float4(DOPos, 1.0), ViewProjMatrix);
	DOTex.x = (1.0f + DOTex.x / DOTex.w) * 0.5f;
	DOTex.y = (1.0f - DOTex.y / DOTex.w) * 0.5f;
	float2 DOTexAdd = DOTex.xy - Tex.xy;
	float SRate = GetAORate(L2Normal, Tex, DOTexAdd, WPos, 0.0);
	

	Color.r*=saturate(1.0-SRate+RFlag2);//*(1.0-RFlag2);

	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	
	float2 STexSampA = SampStep * ViewportSize.y/1080;///min(10,max(1.0,Depth*0.1));
	float2 stexAdd = 0;
	float FColor = tex2D(DirShadowASamp, Tex).r;
	float VGT = 1.0;
	
	[unroll]
	for (int ix =-SAMPNUMSS2; ix <= SAMPNUMSS2; ix++) {
	for (int iy = -SAMPNUMSS2; iy <= SAMPNUMSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;
		
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG =saturate(1.0-distance(AONormal.xyz, Normal.xyz));
		VG *=saturate(1.0-distance(AONormal.a,Depth)*0.1);

		float SColor2 = tex2D(DirShadowASamp, Stex).r;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	FColor /=max(1.0,VGT);	
	Color.r=saturate(FColor);
	

	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////




technique FILTER <
	string Script =

	"RenderColorTarget0=MatAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=MatA;"

	"RenderColorTarget0=WPosKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=PosW;"

	"RenderColorTarget0=NormalDepthKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=ND;"
	
	"RenderColorTarget0=AlbedoMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Albedo;"
	
	"RenderColorTarget0=LumiMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Lumi;"
	
	"RenderColorTarget0=DirShadowAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowA;"
	
	"RenderColorTarget0=DirShadowBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowB;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ScriptExternal=Color;"

	;

> {
	pass MatA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_MatA();
	}
	pass PosW < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_PosW();
	}
	pass ND < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_ND();
	}
	pass Albedo < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Albedo();
	}
	pass Lumi < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Lumi();
	}
	pass DirShadowA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowA();
	}
	pass DirShadowB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowB();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
