// p[^錾

//}eAp[^
static float Roughness=0.5;//\ʂ̑e
static float Metalic=0;//ۂ
static float Specular=0.5;//XyL
static float3 RMS=saturate(float3(Roughness,Metalic,Specular));

static float SSSRate=0.0;
static float Empty=0.0;
static float Empty2=0.0;
static float3 SLM=saturate(float3(SSSRate,Empty,Empty2));

//I[gm[}}bvp[^
static float ANSize=1.0/1024;
float ANScale=1.0;


// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 ProjMatrix		: PROJECTION;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;


float3   LightDirection   : DIRECTION < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*1.6;


float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float    SpecularPower : SPECULARPOWER < string Object = "Geometry"; >;

static float3 MColor2= MaterialEmmisive+MaterialAmbient;
static float3 MColor=pow(MColor2,max(1.0,SpecularPower*0.01));

// eNX`ގ[tl
float4   TextureAddValue   : ADDINGTEXTURE;
float4   TextureMulValue   : MULTIPLYINGTEXTURE;
float4   SphereAddValue    : ADDINGSPHERETEXTURE;
float4   SphereMulValue    : MULTIPLYINGSPHERETEXTURE;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = (float2(0.5, 0.5) / ViewportSize);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}
////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
	float4 Pos      : POSITION;
	float3 Eye    	: TEXCOORD0;
	float2 Tex	    : TEXCOORD1;
	float4 PosW     : TEXCOORD2;
	float4 ScreenTex: TEXCOORD3;
	float3 Normal   : TEXCOORD4;
	float3 Eye2     : TEXCOORD5;
};

// _VF[_
VS_OUTPUT Basic_VS(MMM_SKINNING_INPUT IN,float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	MMM_SKINNING_OUTPUT SkinOut = MMM_SkinnedPositionNormal(IN.Pos, IN.Normal, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);

	Out.PosW = mul(SkinOut.Position, WorldMatrix);

	Out.Normal =SkinOut.Normal;// normalize(mul(Normal, (float3x3)WorldMatrix));

	Out.Pos = mul(Out.PosW,ViewProjMatrix);

	Out.Eye = mul(Out.PosW, ViewMatrix).xyz;
	Out.ScreenTex = Out.Pos;
	Out.Tex = Tex;


	Out.Eye2 = CameraPosition-Out.PosW.xyz;

	return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN, float VFace : VFACE,uniform bool useTexture) : COLOR0
{
	float4 Color=1.0;
	float4 STex = IN.ScreenTex;
	STex.xy /= STex.w;
	STex.x = (1.0f + STex.x) * 0.5f;
	STex.y = (1.0f - STex.y) * 0.5f;
	STex.xy += ViewportOffset;
	
	Color.rgb *=saturate(min(length(MColor),1.8)*normalize(MColor));
	float4 TexColor = tex2D(ObjTexSampler, IN.Tex);
	if ( useTexture ) {
	 TexColor.rgb = lerp(1, TexColor.rgb * TextureMulValue.rgb + TextureAddValue.rgb, TextureMulValue.a + TextureAddValue.a);
	Color *= TexColor;
	}
	Color.a *=MaterialDiffuse.a;
	clip(Color.a - 0.1);
	float3 Normal = normalize(mul(IN.Normal, (float3x3)WorldMatrix));
	Normal=Normal*VFace;

	Color.rgb*=max(1.0,SpecularPower-99.0);
	


	//I[gm[}}bv

	float3 TexColorY1 = tex2D(ObjTexSampler, IN.Tex + float2(0, ANSize));
	float3 TexColorY2 = tex2D(ObjTexSampler, IN.Tex + float2(0, -ANSize));
	float3 TexColorX1 = tex2D(ObjTexSampler, IN.Tex + float2(ANSize, 0));
	float3 TexColorX2 = tex2D(ObjTexSampler, IN.Tex + float2(-ANSize, 0));

	float3 TY = (TexColorY1 - TexColorY2);
	float3 TX = (TexColorX1 - TexColorX2);

	float NY = TY.r + TY.g + TY.b;
	float NX = TX.r + TX.g + TX.b;
	
	float3 EyeVec = normalize(IN.Eye2);
	float4 NormalT1 = tex2D(ObjSphareSampler, IN.Tex);
	float3x3 tangentFrame = compute_tangent_frame(Normal, EyeVec, IN.Tex);
	float3 eyeTangent = normalize(mul(EyeVec, tangentFrame));
	Normal = normalize(mul(normalize(2.0f * saturate(NormalT1.rgb) - 1.0f), tangentFrame));

	//GR[h
	SLM=min(0.99,SLM);
	RMS=min(0.99,RMS);
	Color.rgb = (trunc(Color.rgb*100)*1000+trunc(SLM)*100+trunc(RMS*100)+abs(Normal*0.99))*(step(0.0,Normal)*2.0-1.0);
	
	Color.a=IN.Eye.z;
	
	return Color;
}

// IuWFNg`peNjbN
technique MainTec < string MMDPass = "object"; bool UseTexture = true;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTec2 < string MMDPass = "object"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
// IuWFNg`peNjbN
technique MainTecBS  < string MMDPass = "object_ss"; bool UseTexture = true;> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTecBS2 < string MMDPass = "object_ss"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}
technique ZplotTec	< string MMDPass = "zplot"; >{

}

///////////////////////////////////////////////////////////////////////////////////////////////