// p[^錾
#include"yureHeader2.fx"
// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 ProjMatrix		: PROJECTION;


float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;

float3   LightDirection   : DIRECTION < string Object = "Light"; >;
static float3   LightDir=-LightDirection;

float ShTr : CONTROLOBJECT < string name = "KrShadowB.x"; string item = "Tr"; >;

float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*3.141592;
static float3 SpecularColor = MaterialSpecular * LightSpecular;


// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = (float2(0.5, 0.5) / ViewportSize);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER = LINEAR;
	ADDRESSU = CLAMP;
	ADDRESSV = CLAMP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

shared texture2D TotalKrSSLMap : RENDERCOLORTARGET;
sampler2D TotalKrSSLSamp = sampler_state {
	texture = <TotalKrSSLMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
	float4 Pos      : POSITION;
	float3 Eye    	: TEXCOORD0;
	float2 Tex	    : TEXCOORD1;
	float4 PosW     : TEXCOORD2;
	float3 Normal   : TEXCOORD3;
	float3 Eye2     : TEXCOORD4;
////////////KrShadowǉ/////////////////
	float4 ScreenTex: TEXCOORD5;
////////////KrShadow܂Œǉ///////////////
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

    Pos.xyz+=YurePos(Tex,Pos.xyz);
	Out.PosW = mul(Pos, WorldMatrix);

	Out.Normal = normalize(mul(Normal, (float3x3)WorldMatrix));

	Out.Pos = mul(Out.PosW,ViewProjMatrix);

	Out.Eye = mul(Out.PosW, ViewMatrix);
////////////KrShadowǉ/////////////////
	Out.ScreenTex = Out.Pos;
////////////KrShadow܂Œǉ///////////////
	Out.Tex = Tex;


	Out.Eye2 = CameraPosition-Out.PosW.xyz;

	return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN, float VFace : VFACE,uniform bool useTexture) : COLOR0
{
	float4 Color = 1.0;
	Color.rgb = MaterialEmmisive+ MaterialDiffuse.rgb;
	Color.a *=MaterialDiffuse.a;
	float4 Albedo=Color;
	if ( useTexture ) {
	float4 TexColor = tex2D(ObjTexSampler, IN.Tex);
	//TexColor = pow(TexColor, 2.2);
	Albedo *= TexColor;
    }
	
	clip(Albedo.a - 0.1);
	
	
	float4 STex = IN.ScreenTex;
	STex.xy /= STex.w;
	STex.x = (1.0f + STex.x) * 0.5f;
	STex.y = (1.0f - STex.y) * 0.5f;
	STex.xy += ViewportOffset;
	Color.rgb=tex2D(TotalKrSSLSamp,STex).rgb;
	
	Color.a=1.0;

	return Color;
}

// IuWFNg`peNjbN
technique MainTec < string MMDPass = "object"; bool UseTexture = true;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTec2 < string MMDPass = "object"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
// IuWFNg`peNjbN
technique MainTecBS  < string MMDPass = "object_ss"; bool UseTexture = true;> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTecBS2 < string MMDPass = "object_ss"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}


float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;
// ZtVhEpZlvbg

struct VS_ZValuePlot_OUTPUT {
    float4 Pos : POSITION;              // ˉeϊW
    float4 ShadowMapTex : TEXCOORD0;    // Zobt@eNX`
};

// _VF[_
VS_ZValuePlot_OUTPUT ZValuePlot_VS( float4 Pos : POSITION )
{
    VS_ZValuePlot_OUTPUT Out = (VS_ZValuePlot_OUTPUT)0;

    // Cg̖ڐɂ郏[hr[ˉeϊ
    Out.Pos = mul( Pos, LightWorldViewProjMatrix );

    // eNX`W𒸓_ɍ킹
    Out.ShadowMapTex = Out.Pos;

    return Out;
}

// sNZVF[_
float4 ZValuePlot_PS( float4 ShadowMapTex : TEXCOORD0 ) : COLOR
{
    // RFZlL^
    return float4(ShadowMapTex.z/ShadowMapTex.w,0,0,1);
}

// ZlvbgpeNjbN
technique ZplotTec < string MMDPass = "zplot"; > {
    pass ZValuePlot {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 ZValuePlot_VS();
        PixelShader  = compile ps_2_0 ZValuePlot_PS();
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////